<?php
/*******************************************************************************

 File:         $Id: setup.php 88 2010-12-13 12:25:55Z thurban $
 Modified_On:  $Date: 2010-12-13 13:25:55 +0100 (Mo, 13 Dez 2010) $
 Modified_By:  $Author: thurban $ 
 Language:     Perl
 Encoding:     UTF-8
 Status:       -
 
*******************************************************************************/

function plugin_nmidCreatePDF_install () {
    api_plugin_register_hook('nmidCreatePDF', 'draw_navigation_text', 'nmidCreatePDF_draw_navigation_text', 'setup.php');
    api_plugin_register_hook('nmidCreatePDF', 'poller_bottom', 'nmidCreatePDF_check_scheduledReports', 'setup.php');
    api_plugin_register_hook('nmidCreatePDF', 'top_header_tabs', 'nmidCreatePDF_show_tab', 'setup.php');
    api_plugin_register_hook('nmidCreatePDF', 'top_graph_header_tabs', 'nmidCreatePDF_show_tab', 'setup.php');
    api_plugin_register_hook('nmidCreatePDF', 'config_arrays', 'nmidCreatePDF_config_arrays', 'setup.php');
    api_plugin_register_hook('nmidCreatePDF', 'config_settings', 'nmidCreatePDF_config_settings', 'setup.php');
    api_plugin_register_hook('nmidCreatePDF', 'config_form', 'nmidCreatePDF_config_form','setup.php');
    api_plugin_register_hook('nmidCreatePDF', 'console_after', 'nmidCreatePDF_console_after', 'setup.php');
    api_plugin_register_hook('nmidCreatePDF', 'tree_after', 'nmidCreatePDF_tree_after', 'setup.php');
    api_plugin_register_hook('nmidCreatePDF', 'page_buttons', 'nmidCreatePDF_page_buttons', 'setup.php');
    api_plugin_register_hook('nmidCreatePDF', 'graph_buttons', 'nmidCreatePDF_graph_buttons', 'setup.php');
    api_plugin_register_hook('nmidCreatePDF', 'graph_buttons_thumbnails', 'nmidCreatePDF_graph_buttons', 'setup.php');
    api_plugin_register_hook('nmidCreatePDF', 'tree_view_page_end', 'nmidCreatePDF_tree_view_page_end', 'setup.php');
    api_plugin_register_hook('nmidCreatePDF', 'api_device_save', 'nmidCreatePDF_api_device_save', 'setup.php');
    api_plugin_register_hook('nmidCreatePDF', 'graph_tree_page_buttons', 'nmidCreatePDF_page_buttons', 'setup.php');
	api_plugin_register_hook('nmidCreatePDF', 'weathermap_page_selection_top','nmidCreatePDF_printWeathermapButton', 'setup.php');
	api_plugin_register_hook('nmidCreatePDF', 'device_action_array', 'plugin_nmidCreatePDF_device_action_array', 'setup.php');
	api_plugin_register_hook('nmidCreatePDF', 'device_action_prepare', 'plugin_nmidCreatePDF_device_action_prepare', 'setup.php');
	api_plugin_register_hook('nmidCreatePDF', 'device_action_execute', 'plugin_nmidCreatePDF_device_action_execute', 'setup.php');
    api_plugin_register_realm('nmidCreatePDF', 'debug.php,nmidCreatePDF_orderDSStatsGraphs.php,nmidCreatePDF_addDSStatsReport.php,addToDSStatsReport.php,nmidCreatePDF_createTemplateReport.php,nmidCreatePDF_orderGraphs.php,nmidCreatePDF_scheduler.php,nmidCreatePDF_addScheduledReport.php,addToGraphReport.php,nmidCreatePDF_Reports.php,nmidCreatePDF_addReport.php,nmidCreatePDF_addMultiReport.php,nmidCreatePDF_orderMultiGraphs.php,nmidCreatePDF_Backup.php,nmidCreatePDF_support.php,nmidCreatePDF_debug.php,nmidCreatePDF_ArchiveUserGroups.php,nmidCreatePDF_ArchiveUserGroups_Add.php,nmidCreatePDF_ArchiveUserGroups_AddUser.php,nmidCreatePDF_addWeathermapReport.php', 'NMID - Define PDF Reports', 1195);
    api_plugin_register_realm('nmidCreatePDF', 'nmidCreatePDF_doArchiveReport.php,nmidCreatePDF_Archive.php,nmidCreatePDF_GenerateReports.php,nmidCreatePDF_GenerateReport_now.php', 'NMID - Generate PDF Reports', 1196);
    api_plugin_register_realm('nmidCreatePDF', 'nmidCreatePDF_Availability_DowntimeSchedule.php,nmidCreatePDF_Availability_addDowntimeSchedule.php,nmidCreatePDF_Availability_SLATimeFrame.php,nmidCreatePDF_Availability_addSLATimeFrame.php,nmidCreatePDF_Availability_addSLATimeFrameItem.php,nmidCreatePDF_Availability_SLATimeFrameItem.php', 'NMID - Manage Availability Data', 1197);
    api_plugin_register_realm('nmidCreatePDF', 'nmidCreatePDF_AvailabilityChart.php', 'NMID - View Availability Charts', 1199);
    api_plugin_register_realm('nmidCreatePDF', 'nmidCreatePDF_userArchive.php', 'NMID - View Archived Reports', 1200);
    api_plugin_register_realm('nmidCreatePDF', 'nmidCreatePDF_addZenossReport.php,addToZenossReport.php,nmidCreatePDF_orderZenossReports.php', 'NMID - Manage Zenoss Reports', 1198);
    nmidCreatePDF_setup_table_new ();
}

function plugin_nmidCreatePDF_device_action_array($action) {
	global $config, $database_default;

	include_once($config["library_path"] . "/adodb/adodb.inc.php");
	include_once($config["library_path"] . "/database.php");

	$a_slaItems = db_fetch_assoc("
		SELECT
			id,
			shortDescription
		FROM
			`plugin_nmidCreatePDF_Availability_SLATimeFrame_Table`
	");
	
	foreach ( $a_slaItems as $s_slaItem ) {
		$action['plugin_nmidCreatePDF_device_sla_id_'.$s_slaItem['id']] = 'Set SLA time to ('.$s_slaItem['shortDescription'].')';
	}
    return $action;
}

function plugin_nmidCreatePDF_device_action_prepare($save) {
	# globals used
	global $config, $colors;
	if ( preg_match('/plugin_nmidCreatePDF_device_sla_id_(\d+)/', $save["drp_action"], $matches ) ) { /* sla item id*/
		/* find out which (if any) hosts have been checked, so we can tell the user */
		if (isset($save["host_array"])) {
			/* list affected hosts */
			print "<tr>";
			print "<td class='textArea' bgcolor='#" . $colors["form_alternate1"] . "'>" .
				   "<p>Are you sure you want to change the SLA type of the following hosts ?</p>" .
				   "<p><ul>". $save["host_list"] . "</ul></p>".
				   "</td>";
			print "</tr>";
		}
	}
	return $save; # required for next hook in chain
}

function plugin_nmidCreatePDF_device_action_execute($action) {
	global $config;

	# it's our turn
	if ( preg_match('/plugin_nmidCreatePDF_device_sla_id_(\d)/', $action, $matches ) ) { /* nmidSmokeping Server x */
		if (isset($_POST["selected_items"])) {
			$selected_items = unserialize(stripslashes($_POST["selected_items"]));
			for ($i=0;($i<count($selected_items));$i++) {
				/* ================= input validation ================= */
				input_validate_input_number($selected_items[$i]);
				/* ==================================================== */

				$data = array();
				$data["host_id"] = $selected_items[$i];
				$slaItemId = $matches[1];

				db_execute("UPDATE host SET nmid_host_sla_timeframe = $slaItemId WHERE id=".$data["host_id"]);
			}
		}
	}
	return $action;
}

function nmidCreatePDF_draw_navigation_text ( $nav ) {
    $nav["nmidCreatePDF_Reports.php:"]     = array("title" => "CereusReporting Reports", "mapping" => "index.php:", "url" => "nmidCreatePDF_Reports.php", "level" => "1");
    $nav["nmidCreatePDF_addReport.php:"] = array("title" => "CereusReporting Report", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_addReport.php", "level" => "2");
    $nav["nmidCreatePDF_addReport.php:add"] = array("title" => "(Add)", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_addReport.php", "level" => "2");
    $nav["nmidCreatePDF_addReport.php:update"] = array("title" => "(Edit)", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_addReport.php", "level" => "2");
    $nav["nmidCreatePDF_addReport.php:actions"] = array("title" => "(Actions)", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_addReport.php", "level" => "2");
    
	// Report Scheduler
    $nav["nmidCreatePDF_scheduler.php:"]     = array("title" => "CereusReporting Report Schedules", "mapping" => "index.php:", "url" => "nmidCreatePDF_scheduler.php", "level" => "1");
    $nav["nmidCreatePDF_addScheduledReport.php:add"] = array("title" => "(Add)", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_addScheduledReportphp", "level" => "2");
    $nav["nmidCreatePDF_addScheduledReport.php:update"] = array("title" => "(Edit)", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_addScheduledReport.php", "level" => "2");

	// Report Generation
    $nav["nmidCreatePDF_GenerateReports.php:"]     = array("title" => "CereusReporting Generate Report", "mapping" => "index.php:", "url" => "nmidCreatePDF_GenerateReports.php", "level" => "1");
    $nav["nmidCreatePDF_GenerateReport_now.php:"] = array("title" => "CereusReporting Generate Report Now", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_GenerateReport_now", "level" => "2");
    
    $nav["nmidCreatePDF_createTemplateReport.php:"] = array("title" => "Create new Template Report", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_createTemplateReport.php", "level" => "1");
    
	// Archiving
    $nav["nmidCreatePDF_Archive.php:"]     = array("title" => "CereusReporting Archive", "mapping" => "index.php:", "url" => "nmidCreatePDF_Archive.php", "level" => "1");
    $nav["nmidCreatePDF_doArchiveReport.php:view"] = array("title" => "(View)", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_doArchiveReport.php", "level" => "2");
    $nav["nmidCreatePDF_doArchiveReport.php:download"] = array("title" => "(Download)", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_doArchiveReport.php", "level" => "2");
    
    // DSStats Support
    $nav["nmidCreatePDF_addDSStatsReport.php:"]     = array("title" => "DSStats Reports", "mapping" => "index.php:", "url" => "nmidCreatePDF_addDSStatsReport.php", "level" => "2");
    $nav["nmidCreatePDF_addDSStatsReport.php:add"]     = array("title" => "DSStats Reports", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_addDSStatsReport.php", "level" => "2");

    // Multi Report
    $nav["nmidCreatePDF_addMultiReport.php:"]     = array("title" => "Multi Reports", "mapping" => "index.php:", "url" => "nmidCreatePDF_addMultiReport.php", "level" => "1");
    $nav["nmidCreatePDF_addMultiReport.php:edit"]     = array("title" => "(Edit)", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_addMultiReport.php", "level" => "2");
    $nav["nmidCreatePDF_addMultiReport.php:add"]     = array("title" => "(Add)", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_addMultiReport.php", "level" => "2");
	$nav["nmidCreatePDF_addWeathermapReport.php:"] = array("title" => "(Add Weathermap)", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_addMultiReport.php", "level" => "2");

    // Support Page - CRC-17
    $nav["nmidCreatePDF_debug.php:"]     = array("title" => "Support Page", "mapping" => "index.php:", "url" => "nmidCreatePDF_debug.php", "level" => "1");
    $nav["nmidCreatePDF_support.php:"]   = array("title" => "Support Page", "mapping" => "index.php:", "url" => "nmidCreatePDF_support.php", "level" => "1");
    
    // Backup
    $nav["nmidCreatePDF_Backup.php:"]     = array("title" => "Backup Reports", "mapping" => "index.php:", "url" => "nmidCreatePDF_Backup.php", "level" => "1");
    $nav["nmidCreatePDF_Backup.php:add"]     = array("title" => "(Add)", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_Backup.php", "level" => "2");
    
    // Availability Data
    $nav["nmidCreatePDF_Availability_DowntimeSchedule.php:"]     = array("title" => "Availability Data", "mapping" => "index.php:", "url" => "nmidCreatePDF_Availability_DowntimeSchedule.php", "level" => "1");
    $nav["nmidCreatePDF_Availability_addDowntimeSchedule.php:add"]     = array("title" => "(Add)", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_Availability_addDowntimeSchedule.php", "level" => "2");
    $nav["nmidCreatePDF_Availability_addDowntimeSchedule.php:update"]     = array("title" => "(Update)", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_Availability_addDowntimeSchedule.php", "level" => "2");
    
    $nav["nmidCreatePDF_Availability_SLATimeFrame.php:"]     = array("title" => "SLA TimeFrame Item Data", "mapping" => "index.php:", "url" => "nmidCreatePDF_Availability_SLATimeFrame.php", "level" => "1");
    $nav["nmidCreatePDF_Availability_addSLATimeFrame.php:add"]     = array("title" => "(Add)", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_Availability_addSLATimeFrame.php", "level" => "2");
    $nav["nmidCreatePDF_Availability_addSLATimeFrame.php:update"]     = array("title" => "(Update)", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_Availability_addSLATimeFrame.php", "level" => "2");
    
    $nav["nmidCreatePDF_Availability_SLATimeFrameItem.php:"]     = array("title" => "SLA TimeFrame Item Data", "mapping" => "index.php:", "url" => "nmidCreatePDF_Availability_SLATimeFrameItem.php", "level" => "1");
    $nav["nmidCreatePDF_Availability_addSLATimeFrameItem.php:add"]     = array("title" => "(Add)", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_Availability_addSLATimeFrameItem.php", "level" => "2");
    $nav["nmidCreatePDF_Availability_addSLATimeFrameItem.php:update"]     = array("title" => "(Update)", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_Availability_addSLATimeFrameItem.php", "level" => "2");
       
    // Zenoss
    $nav["nmidCreatePDF_addZenossReport.php:"] = array("title" => "Zenoss Report", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_addZenossReport.php", "level" => "2");
    $nav["nmidCreatePDF_addZenossReport.php:add"] = array("title" => "(Add)", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_addZenossReport.php", "level" => "2");
    $nav["nmidCreatePDF_addZenossReport.php:update"] = array("title" => "(Edit)", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_addZenossReport.php", "level" => "2");
	
	// User Groups
    $nav["nmidCreatePDF_ArchiveUserGroups.php:"] = array("title" => "User Groups", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_ArchiveUserGroups.php", "level" => "1");
    $nav["nmidCreatePDF_ArchiveUserGroups_Add.php:add"] = array("title" => "(Add)", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_ArchiveUserGroups.php", "level" => "2");
    $nav["nmidCreatePDF_ArchiveUserGroups_Add.php:update"] = array("title" => "(Edit)", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_ArchiveUserGroups.php", "level" => "2");
    $nav["nmidCreatePDF_ArchiveUserGroups_AddUser.php:add"] = array("title" => "(Add User)", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_ArchiveUserGroups.php", "level" => "3");

    $nav["nmidCreatePDF_userArchive.php:"] = array("title" => "User Archive", "mapping" => "index.php:,?", "url" => "nmidCreatePDF_userArchive.php", "level" => "1");

	// Weathermap Reports
	
    return $nav;
}

function nmidCreatePDF_printWeathermapButton ( $args ) {
      global $config;
      print "<td align=right><a href='".$args['mapId']."'><img border=0 src='".$config['url_path']."plugins/nmidCreatePDF/images/acroread.png'></a></td>";
}

function nmidCreatePDF_check_scheduledReports () {
    global $config, $database_type, $database_default,$database_hostname,$database_username,$database_password,$database_port;
	include_once($config["library_path"] . "/database.php");
    $dir = dirname(__FILE__);
	include_once($dir.'/functions.php');
	// START Availability Report Data Generation
	if ( read_config_option('nmid_avail_winservice_enabled') ) {
		nmidCreatePDF_process_service_states();
	}
	if ( read_config_option('nmid_avail_enabled') ) {
		nmidCreatePDF_process_polls();
	}
	// END Availability Report Data Generation
	if ( read_config_option('nmid_pdfscheduletype') == 'cron' ) {
		return;
	}
	else {
        if ( ( EDITION == "CORPORATE" ) || ( isPluginLicensed( 'SCHEDULER' ) ) || ( isSMBServer() ) ) {
			$dir = dirname(__FILE__);
			$mainDir = preg_replace("@plugins.nmidCreatePDF@","",$dir);
			
			chdir($dir);
			include_once('functions.php');
		
			
			cacti_log('NMID CereusReporting - Starting Scheduled Report Check',true, 'POLLER');
		
			// Check Report Schedule
			nmidCreatePDF_process_schedule( 'POLLER' );
		
			cacti_log('NMID CereusReporting - Scheduled Report Check Finished',true, 'POLLER');
		}
	}
}

function nmidCreatePDF_show_tab () {
	global $config, $user_auth_realms, $user_auth_realm_filenames;
    $cp = '';
	if (isset($user_auth_realm_filenames{basename('nmidCreatePDF_GenerateReports.php')})) {
		$realm_id2 = $user_auth_realm_filenames{basename('nmidCreatePDF_GenerateReports.php')};
	}
    if ( api_user_realm_auth('nmidCreatePDF_userArchive.php')) {
        if (basename($_SERVER['PHP_SELF']) == 'nmidCreatePDF_userArchive.php' )
        {
            $cp = true;
        }
        print '<a href="' . $config['url_path'] . 'plugins/nmidCreatePDF/nmidCreatePDF_userArchive.php"><img src="' . $config['url_path'] . 'plugins/nmidCreatePDF/images/tab_nmidCreatePDF' . ($cp ? '_red': '') . '.gif" alt="CereusReporting" align="absmiddle" border="0"></a>';
		
	}
    elseif (api_user_realm_auth('nmidCreatePDF_GenerateReports.php')) {
        $cp = false;
        if (basename($_SERVER['PHP_SELF']) == 'nmidCreatePDF_GenerateReports.php' || basename($_SERVER['PHP_SELF']) == 'nmidCreatePDF_GenerateReport_now.php' )
        {
            $cp = true;
        }
        print '<a href="' . $config['url_path'] . 'plugins/nmidCreatePDF/nmidCreatePDF_GenerateReports.php"><img src="' . $config['url_path'] . 'plugins/nmidCreatePDF/images/tab_nmidCreatePDF' . ($cp ? '_red': '') . '.gif" alt="CereusReporting" align="absmiddle" border="0"></a>';
    }
}

function nmidCreatePDF_config_form() {
    global $fields_tree_edit,$fields_host_edit;
    $dir = dirname(__FILE__);
	include_once($dir.'/functions.php');
	
    if ( ( EDITION == "CORPORATE" ) || ( isPluginLicensed( 'TEMPLATING' ) ) || ( isSMBServer() ) ) {
		/* only needed for the Pro and Corporate Edition */
		$temp = array(
			"nmidCreatePDF_cover_page" => array(
					"method" => "textbox",
					"friendly_name" => "PDF Cover Page",
					"description" => "PDF File to add as cover page for this tree.",
					"value" => "|arg1:nmidCreatePDF_cover_page|",
					"max_length" => "255",
					),
			"nmidCreatePDF_cover_logo" => array(
					"method" => "textbox",
					"friendly_name" => "PDF Cover Logo",
					"description" => "Image file to use for the logo.",
					"value" => "|arg1:nmidCreatePDF_cover_logo|",
					"max_length" => "255",
					)
		);
		
		if (isset($fields_tree_edit))
			$fields_tree_edit = array_merge($fields_tree_edit, $temp);
		else
			$fields_tree_edit = $temp;
    }

    if ( ( EDITION == "CORPORATE" ) || ( isPluginLicensed( 'AVAILABILITY' ) ) || ( isSMBServer() ) ) {
        $sql = "SELECT
              `plugin_nmidCreatePDF_Availability_SLATimeFrame_Table`.`Id`,
              `plugin_nmidCreatePDF_Availability_SLATimeFrame_Table`.`shortDescription`
            FROM
              `plugin_nmidCreatePDF_Availability_SLATimeFrame_Table`";
        $result = mysql_query( $sql );
    
        $ar_slaTimeFrames = array ();
        $ar_slaTimeFrames["0"] = "none";
        while ( $row = mysql_fetch_assoc( $result ) ) {
            $ar_slaTimeFrames[ $row['Id'] ] = $row['shortDescription'];
        }

		$fields_host_edit2 = $fields_host_edit;
		$fields_host_edit3 = array();
		foreach ($fields_host_edit2 as $f => $a) {
				$fields_host_edit3[$f] = $a;
				if ($f == 'disabled') {
						$fields_host_edit3["nmid_host_sla"] = array(
								"method" => "textbox",
								"friendly_name" => "Host SLA",
								"description" => "HOST SLA for the Availability Report.",
								"value" => "|arg1:nmid_host_sla|",
								"max_length" => "10",
								"form_id" => false
						);
						$fields_host_edit3["nmid_host_sla_timeframe"] = array(
								"method" => "drop_array",
								"friendly_name" => "Host SLA TimeFrame",
								"description" => "HOST SLA TimeFrame for the Availability Report.",
								"value" => "|arg1:nmid_host_sla_timeframe|",
								"max_length" => "10",
                                "array" => $ar_slaTimeFrames,
								"form_id" => false
						);
				}
		}
		$fields_host_edit = $fields_host_edit3;
	}
}

function nmidCreatePDF_api_device_save ($save) {
    $dir = dirname(__FILE__);
	include_once($dir.'/functions.php');	
    if ( ( EDITION == "CORPORATE" ) || ( isPluginLicensed( 'AVAILABILITY' ) ) || ( isSMBServer() ) ) {
        if (isset($_POST['nmid_host_sla'])) {
            $save["nmid_host_sla"] = form_input_validate($_POST['nmid_host_sla'], "nmid_host_sla", "", true, 10);
        } else {
            $save['nmid_host_sla'] = form_input_validate('', "nmid_host_sla", "", true, 10);
        }
        if (isset($_POST['nmid_host_sla_timeframe'])) {
            $save["nmid_host_sla_timeframe"] = form_input_validate($_POST['nmid_host_sla_timeframe'], "nmid_host_sla_timeframe", "", true, 10);
        } else {
            $save['nmid_host_sla_timeframe'] = form_input_validate('', "nmid_host_sla_timeframe", "", true, 10);
        }
	}
    return $save;
}

function nmidCreatePDF_graph_buttons($args) {
    global $config;
    if (api_user_realm_auth('nmidCreatePDF_GenerateReports.php')) {
        $local_graph_id = $args[1]['local_graph_id'];
        if ( $args[1]['rra'] == "all" )
        {
            echo '<input type=checkbox onClick="setData(\'lgi_'.$local_graph_id.'\');"  id="lgi_'.$local_graph_id.'" name="lgi_'.$local_graph_id.'" value="'.$local_graph_id.'"><br>'."\n";			
        }
        else {
            echo '<input disabled type=checkbox checked id="lgi_'.$local_graph_id.'" name="lgi_'.$local_graph_id.'" value="'.$local_graph_id.'"><br>'."\n";			
        }
    }    
}

function nmidCreatePDF_tree_view_page_end($args) {
    global $config;
    if (api_user_realm_auth('nmidCreatePDF_GenerateReports.php')) {
        $mainUrl = $_SERVER['PHP_SELF'];
        if ( preg_match("/graph.php/i", $mainUrl ) ) {
        echo '<tr>';
        }
        echo "</form>\n";
        if ( preg_match("/graph.php/i", $mainUrl ) ) {
            echo '</tr>';
        }
    }
}
    
function plugin_nmidCreatePDF_uninstall () {
	// Do any extra Uninstall stuff here
}

function nmidCreatePDF_page_buttons($args) {
    global $config, $colors, $plugin_architecture;
    if (api_user_realm_auth('nmidCreatePDF_GenerateReports.php')) {
        $mode = $args['mode'];
        if ( $mode == 'tree' ) {
            $tree_id   = $args['treeid'];
            $leaf_id   = $args['leafid'];
            $starttime = $args['starttime'];
            $endtime   = $args['endtime'];
            $timespan  = $args['timespan'];
        }
        elseif ( $mode == 'mrtg' ) {
            $lgid 	   = $args['lgid'];
            $rraid     = $args['rraid'];
        }
        
        $txt['P'] = 'Portrait';
        $txt['L'] = 'Landscape';
        $txt['0'] = 'Default';
        $txt['2x2'] = '2 Graphs, 2 Columns';
        if ( $plugin_architecture['version'] == "2.9" ) {
            if ( $mode == 'tree') {
                html_graph_start_box("", "100%", $colors["header"], "3", "center", "");
                ?>
                <tr bgcolor="<?php print $colors["panel"];?>" class="noprint">
                    <td class="noprint">
                        <table width="100%" cellpadding="0" cellspacing="0">
                            <tr><td align=right>
                               <table><tr><td>
                                <?php
            }
            elseif ( $mode == 'mrtg' ) {
                echo "<tr align=right><td align=right>";
            }
        }
        echo '
            <SCRIPT TYPE="text/javascript">
            <!--    
            function setAction(a) {
                if ( a == 1 ) {
                    document.nmidCreatePDF_Form.action = "'.$config['url_path'].'plugins/nmidCreatePDF/addToGraphReport.php";
                }
                if ( a == 2 ) {
                    document.nmidCreatePDF_Form.action = "'.$config['url_path'].'plugins/nmidCreatePDF/createPDFReport.php";
                }
                if ( a == 3 ) {
                    document.nmidCreatePDF_Form.action = "'.$config['url_path'].'plugins/nmidCreatePDF/createPDFReport_mrtgStyle.php";
                }
                if ( a == 4 ) {
                    document.nmidCreatePDF_Form.action = "'.$config['url_path'].'plugins/nmidCreatePDF/nmidCreatePDF_createTemplateReport.php";
                }
                document.nmidCreatePDF_Form.submit()
                
            }
            
            function setData(a) {
                    if ( document.nmidCreatePDF_Form.lgi_fix.value.match(";"+a) ) {
                            document.nmidCreatePDF_Form.lgi_fix.value = document.nmidCreatePDF_Form.lgi_fix.value.replace(";"+a , "");
                    } else {
                            document.nmidCreatePDF_Form.lgi_fix.value = document.nmidCreatePDF_Form.lgi_fix.value + ";" + a;
                    }
            }
    
            //-->
            </SCRIPT>
        ';
    
       //action='".$config['url_path']."plugins/nmidCreatePDF/addToGraphReport.php'
        echo "<table><tr>";
    
        echo "<form name=nmidCreatePDF_Form method=post>\n";
        // EXPRESS, Pro and Corporate features
        if ( $mode == 'tree' ) {
            if (api_user_realm_auth('nmidCreatePDF_addReport.php')) {
                echo "<td style='border-right-style: solid;border-right-width: thin;'>\n".
                    "<select name='report_id'>\n".
                    "<OPTGROUP label='Please choose'>\n";
                    $GraphReports = db_fetch_assoc("
                    SELECT `ReportId`,`Name` FROM `plugin_nmidCreatePDF_Reports` WHERE `reportType` = 1 OR `reportType` = 3 ;
                    ");
                    foreach ($GraphReports as $report)
                    {
                       echo "<option value='".$report['ReportId']."'>".$report['Name']."</option>\n";
                    }
                echo "</OPTGROUP>\n".		
                    "</select>\n".
                     "</td>\n";
                echo "<td style='border-right-style: solid;border-right-width: medium;'><input type='image' src='plugins/nmidCreatePDF/images/add.png' onclick=\"setAction('1')\" value='Add to Report' alt='Add to Report'></td>\n";
            }
        }
        // Free and upwards
        if ( $mode == 'tree' ) {
            //echo "<form name=ReportGeneration method=post action='".$config['url_path']."plugins/nmidCreatePDF/createPDFReport.php'>";
            echo "<td>";
            echo "<input type=hidden name=starttime value='".$starttime."'>";
            echo "<input type=hidden name=endtime value='".$endtime."'>";
            echo "<input type=hidden name=leaf_id value='".$leaf_id."'>";
            echo "<input type=hidden name=timespan value='".$timespan."'>";
            echo "<input type=hidden name=tree_id value='".$tree_id."'>";
            echo "<input type=hidden name=lgi_fix value=''>";
            echo "</td>";
        }
        elseif ( $mode == 'mrtg' ) {
            //echo "<form method=post action='".$config['url_path']."plugins/nmidCreatePDF/createPDFReport_mrtgStyle.php'>";
            echo "<td>";
            echo "<input type=hidden name=lgid value='".$lgid."'>";
            echo "<input type=hidden name=rraid value='".$rraid."'>";
            echo "</td>";
        }
        echo "<td style='border-right-style: solid;border-right-width: thin;'>".
            "<select name='nmid_pdffontsize'>".
            "<option value='".read_config_option('nmid_pdffontsize')."'>".read_config_option('nmid_pdffontsize')."</option>".
            "<OPTGROUP label='Please choose'>".		
            "<option value='6'>6</option>".
            "<option value='8'>8</option>".
            "<option value='10'>10</option>".
            "<option value='12'>12</option>".
            "<option value='14'>14</option>".
            "</OPTGROUP>".		
            "</select>".
             "</td>";
        echo "<td style='border-right-style: solid;border-right-width: thin;'>".
            "<select name='nmid_pdfpagesize'>".
            "<option value='".read_config_option('nmid_pdfpagesize')."'>".read_config_option('nmid_pdfpagesize')."</option>".
            "<OPTGROUP label='Please choose'>".
            "<option value='A3'>A3</option>".
            "<option value='A4'>A4</option>".
            "<option value='A5'>A5</option>".
            "<option value='Letter'>Letter</option>".
            "<option value='Legal'>Legal</option>".
            "</OPTGROUP>".
            "</select>".
             "</td>";
        echo "<td style='border-right-style: solid;border-right-width: thin;'>".
            "<select name='nmid_pdfpageorientation'>".
            "<option value='".read_config_option('nmid_pdfpageorientation')."'>".$txt[read_config_option('nmid_pdfpageorientation')]."</option>".
            "<OPTGROUP label='Please choose'>".		
            "<option value='P'>Portrait</option>".
            "<option value='L'>Landscape</option>".
            "</OPTGROUP>".		
            "</select>".
             "</td>";
        echo "<td style='border-right-style: solid;border-right-width: thin;'>".
            "<select name='nmid_pdfgraphPerPage'>".
            "<option value='".read_config_option('nmid_pdfgraphPerPage')."'>".$txt[read_config_option('nmid_pdfgraphPerPage')]."</option>".
            "<OPTGROUP label='Please choose'>".		
            "<option value='0'>Default</option>".
            "<option value='2x2'>2 Graphs, 2 Columns</option>".
            "</OPTGROUP>".		
            "</select>".
             "</td>";
        if ( $mode == 'tree' ) {
            echo "<td style='border-right-style: solid;border-right-width: thin;'>Include Sub-Leafs <input type=checkBox name='nmid_pdfAddSubLeafs' value=1>&nbsp;</td>";
            // not implemented yet
            // echo "<td style='border-right-style: solid;border-right-width: thin;'><input type='image' src='plugins/nmidCreatePDF/images/create_template.png' onclick=\"setAction('4')\" value='Create Report Template' alt='Create Report Template'></td>";
            echo "<td><input type='image' src='plugins/nmidCreatePDF/images/acroread.png' onclick=\"setAction('2')\" value='DefaultType' alt='DefaultType'></td>";
            
        }
        else {
            echo "<td><input type='image' src='plugins/nmidCreatePDF/images/acroread.png' onclick=\"setAction('3')\" value='MRTGStyle' alt='MRTGStyle'></td>";
        }
    
        echo "</tr></table>\n";
        if ( $plugin_architecture['version'] == "2.9" ) {
            if ( $mode == 'tree') {
                                ?>
                               </td></tr></table>
                            </td></tr>
                        </table>
                    </td>
                </tr>
                <?php
                html_graph_end_box();
                print "<br>";
            }
            elseif ( $mode == 'mrtg' ) {
                echo "</td></tr>";
            }
        }
    }
}


function plugin_nmidCreatePDF_check_config () {
	// Here we will check to ensure everything is configured
	nmidCreatePDF_check_upgrade();

	return true;
}

function plugin_nmidCreatePDF_upgrade () {
	// Here we will upgrade to the newest version
	nmidCreatePDF_check_upgrade ();
	return false;
}

function plugin_nmidCreatePDF_version () {
	return nmidCreatePDF_version();
}

function nmidCreatePDF_check_upgrade () {
	// We will only run this on pages which really need that data ...
	$files = array('nmidCreatePDF_orderGraphs.php,nmidCreatePDF_scheduler.php,nmidCreatePDF_addScheduledReport.php,addToGraphReport.php,nmidCreatePDF_Reports.php,nmidCreatePDF_addReport.php');
	if (isset($_SERVER['PHP_SELF']) && !in_array(basename($_SERVER['PHP_SELF']), $files))
		return;
	
	$current = nmidCreatePDF_version ();
	$current = $current['version'];
	$old = db_fetch_cell("SELECT version FROM plugin_config WHERE directory='nmidCreatePDF'");
	if ($current != $old) {
		nmidCreatePDF_setup_table( $old );
	}
}

function nmidCreatePDF_check_dependencies() {
    global $plugins, $config;
    
    // we need to check for the availability of the settings plugin
    if (
        (!in_array('settings', $plugins)) &&    
        (db_fetch_cell("SELECT directory FROM plugin_config WHERE directory='settings' AND status=1") == "")
        ) {
        // it's not in the global plugins var ( old PIA mode ) AND
        // it is not configured via the new PIA mode
        return false;
    }
    return true;
}


function nmidCreatePDF_setup_table_new () {
    global $config, $database_default;
    include_once($config["library_path"] . "/database.php");

    // Check if the nmidCreatePDF tables are present
    $s_sql	= 'show tables from `' . $database_default . '`';
    $result = db_fetch_assoc( $s_sql ) or die ( mysql_error() );
    $a_tables = array();
    
    $sql 	= array();

    foreach($result as $index => $array) {
	    foreach($array as $table) {
		    $a_tables[] = $table;
	    }
    }

    api_plugin_db_add_column ('nmidCreatePDF', 'graph_tree', array('name' => 'nmidCreatePDF_cover_page', 'type' => 'varchar(1024)', 'NULL' => true, 'default' => ''));	
    api_plugin_db_add_column ('nmidCreatePDF', 'graph_tree', array('name' => 'nmidCreatePDF_cover_logo', 'type' => 'varchar(1024)', 'NULL' => true, 'default' => ''));	
    api_plugin_db_add_column ('nmidCreatePDF', 'host', array('name' => 'nmid_host_sla', 'type' => 'varchar(1024)', 'NULL' => true, 'default' => ''));
    api_plugin_db_add_column ('nmidCreatePDF', 'host', array('name' => 'nmid_host_sla_timeframe', 'type' => 'varchar(1024)', 'NULL' => true, 'default' => ''));

	if (!in_array('plugin_nmidCreatePDF_Reports_scheduler', $a_tables)) {
		// Create Report Schedule Table
		$data = array();
		$data['columns'][] = array('name' => 'ScheduleId', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false, 'auto_increment' => true);
		$data['columns'][] = array('name' => 'Name', 'type' => 'text', 'NULL' => true);
		$data['columns'][] = array('name' => 'Date', 'type' => 'varchar(1024)', 'NULL' => false);
		$data['columns'][] = array('name' => 'lastRunDate', 'type' => 'varchar(1024)', 'NULL' => false);
		$data['columns'][] = array('name' => 'isRecurring', 'type' => 'varchar(5)', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'frequency', 'type' => 'varchar(255)', 'NULL' => false, 'default' => 'Active');
		$data['columns'][] = array('name' => 'Status', 'type' => 'varchar(5)', 'NULL' => false, 'default' => '1');
		$data['columns'][] = array('name' => 'Creator', 'type' => 'varchar(255)', 'NULL' => true);
		$data['columns'][] = array('name' => 'ReportID', 'type' => 'varchar(255)', 'NULL' => true);
		$data['columns'][] = array('name' => 'Recipients', 'type' => 'text', 'NULL' => true);
		$data['columns'][] = array('name' => 'Description', 'type' => 'text', 'NULL' => true);
		$data['columns'][] = array('name' => 'Attachments', 'type' => 'text', 'NULL' => true);
		$data['columns'][] = array('name' => 'archiveReport', 'type' => 'varchar(5)', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'archiveUserGroupId', 'type' => 'mediumint(25)','unsigned' => 'unsigned', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'runNow', 'type' => 'mediumint(25)','unsigned' => 'unsigned', 'NULL' => false, 'default' => '0');
		$data['primary'] = 'ScheduleId';
		$data['keys'][] = array('name' => 'lastRunDate',	'columns' => 'lastRunDate');
		$data['type'] = 'MyISAM';
		$data['comment'] = 'CereusReporting Report Schedules';
		api_plugin_db_table_create ('nmidCreatePDF', 'plugin_nmidCreatePDF_Reports_scheduler', $data);
	}
	
	if (!in_array('plugin_nmidCreatePDF_Reports', $a_tables)) {
		// Create Report Table
		$data = array();
		$data['columns'][] = array('name' => 'ReportId', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false, 'auto_increment' => true);
		$data['columns'][] = array('name' => 'Name', 'type' => 'text', 'NULL' => true);
		$data['columns'][] = array('name' => 'Logo', 'type' => 'text', 'NULL' => true);
		$data['columns'][] = array('name' => 'CoverPage', 'type' => 'text', 'NULL' => true);
		$data['columns'][] = array('name' => 'includeSubDirs', 'type' => 'varchar(5)', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'leafId', 'type' => 'varchar(5)', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'reportType', 'type' => 'varchar(5)', 'NULL' => false, 'default' => '0');
		# 0 = on demand, 1 = hourly, 2 = daily, 3 = weekly, 4 = monthly, 5 = yearly
		$data['columns'][] = array('name' => 'type', 'type' => 'varchar(255)', 'NULL' => false, 'default' => '0');  
		$data['columns'][] = array('name' => 'pageSize', 'type' => 'varchar(255)', 'NULL' => false, 'default' => '0');  
		$data['columns'][] = array('name' => 'pageOrientation', 'type' => 'varchar(255)', 'NULL' => false, 'default' => '0');  
		$data['columns'][] = array('name' => 'pageGraphFormat', 'type' => 'varchar(255)', 'NULL' => false, 'default' => '0');  
		$data['columns'][] = array('name' => 'Description', 'type' => 'text', 'NULL' => true);
		$data['columns'][] = array('name' => 'outputType', 'type' => 'text', 'NULL' => true);
		$data['columns'][] = array('name' => 'showGraphHeader', 'type' => 'varchar(5)', 'NULL' => false, 'default' => '1');
		$data['primary'] = 'ReportId';
		$data['keys'][] = array('name' => 'leafId',	'columns' => 'leafId');
		$data['type'] = 'MyISAM';
		$data['comment'] = 'CereusReporting Reports';
		api_plugin_db_table_create ('nmidCreatePDF', 'plugin_nmidCreatePDF_Reports', $data);	
	}
	
	if (!in_array('plugin_nmidCreatePDF_Archives', $a_tables)) {
		// Create Report Archive Table
		$data = array();
		$data['columns'][] = array('name' => 'ArchiveId', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false, 'auto_increment' => true);
		$data['columns'][] = array('name' => 'Name', 'type' => 'text', 'NULL' => true );
		$data['columns'][] = array('name' => 'Description', 'type' => 'text', 'NULL' => true);
		$data['columns'][] = array('name' => 'startDate', 'type' => 'varchar(1024)', 'NULL' => true);
		$data['columns'][] = array('name' => 'endDate', 'type' => 'varchar(1024)', 'NULL' => true);
		$data['columns'][] = array('name' => 'archiveDate', 'type' => 'varchar(1024)', 'NULL' => true);
		$data['columns'][] = array('name' => 'filePath', 'type' => 'text', 'NULL' => true);
		$data['columns'][] = array('name' => 'ReportId', 'type' => 'mediumint(25)','unsigned' => 'unsigned', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'UserGroupId', 'type' => 'mediumint(25)','unsigned' => 'unsigned', 'NULL' => false, 'default' => '0');
		$data['primary'] = 'ArchiveId';
		$data['keys'][] = array('name' => 'ReportId',	'columns' => 'ReportId');
		$data['type'] = 'MyISAM';
		$data['comment'] = 'CereusReporting Graph Report Archive';
		api_plugin_db_table_create ('nmidCreatePDF', 'plugin_nmidCreatePDF_Archives', $data);	
	}

	if (!in_array('plugin_nmidCreatePDF_UserGroups', $a_tables)) {
		// Create Report Archive Table
		$data = array();
		$data['columns'][] = array('name' => 'GroupId', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false, 'auto_increment' => true);
		$data['columns'][] = array('name' => 'Name', 'type' => 'text', 'NULL' => true );
		$data['columns'][] = array('name' => 'Description', 'type' => 'text', 'NULL' => true);
		$data['primary'] = 'GroupId';
		$data['keys'][] = array('name' => 'GroupId',	'columns' => 'GroupId');
		$data['type'] = 'MyISAM';
		$data['comment'] = 'CereusReporting Archive User Group';
		api_plugin_db_table_create ('nmidCreatePDF', 'plugin_nmidCreatePDF_UserGroups', $data);
		
		$sql[] = "INSERT INTO `plugin_nmidCreatePDF_UserGroups` (`GroupId`, `Name`,`Description` ) VALUES (1, 'Default Group','Default Group');";
	}
	
	if (!in_array('plugin_nmidCreatePDF_UserGroupList', $a_tables)) {
		// Create Report Archive Table
		$data = array();
		$data['columns'][] = array('name' => 'GroupListId', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false, 'auto_increment' => true);
		$data['columns'][] = array('name' => 'UserId', 'type' => 'mediumint(25)','unsigned' => 'unsigned', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'UserGroupId', 'type' => 'mediumint(25)','unsigned' => 'unsigned', 'NULL' => false, 'default' => '0');
		$data['primary'] = 'GroupListId';
		$data['keys'][] = array('name' => 'GroupListId',	'columns' => 'GroupListId');
		$data['type'] = 'MyISAM';
		$data['comment'] = 'CereusReporting Archive User Group List';
		api_plugin_db_table_create ('nmidCreatePDF', 'plugin_nmidCreatePDF_UserGroupList', $data);	

		$sql[] = "INSERT INTO `plugin_nmidCreatePDF_UserGroupList` (`GroupListId`, `UserId`,`UserGroupId` ) VALUES (1, 1, 1);";

	}
	
	// Table for the "Read Report" List
	if (!in_array('plugin_nmidCreatePDF_UserReportList', $a_tables)) {
		// Create Report Archive Table
		$data = array();
		$data['columns'][] = array('name' => 'ReportReadId', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false, 'auto_increment' => true);
		$data['columns'][] = array('name' => 'UserId', 'type' => 'mediumint(25)','unsigned' => 'unsigned', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'ArchiveId', 'type' => 'mediumint(25)','unsigned' => 'unsigned', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'Status', 'type' => 'varchar(5)', 'NULL' => false, 'default' => '2');
		$data['primary'] = 'ReportReadId';
		$data['keys'][] = array('name' => 'ReportReadId',	'columns' => 'ReportReadId');
		$data['type'] = 'MyISAM';
		$data['comment'] = 'CereusReporting Archive User Report List';
		api_plugin_db_table_create ('nmidCreatePDF', 'plugin_nmidCreatePDF_UserReportList', $data);	
	}	
	
	if (!in_array('plugin_nmidCreatePDF_UserGroupReports', $a_tables)) {
		// Create Report Archive Table
		$data = array();
		$data['columns'][] = array('name' => 'GroupReportId', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false, 'auto_increment' => true);
		$data['columns'][] = array('name' => 'ArchiveId', 'type' => 'mediumint(25)','unsigned' => 'unsigned', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'UserGroupId', 'type' => 'mediumint(25)','unsigned' => 'unsigned', 'NULL' => false, 'default' => '0');
		$data['primary'] = 'GroupReportId';
		$data['keys'][] = array('name' => 'GroupReportId',	'columns' => 'GroupReportId');
		$data['type'] = 'MyISAM';
		$data['comment'] = 'CereusReporting Archive Report Group List';
		api_plugin_db_table_create ('nmidCreatePDF', 'plugin_nmidCreatePDF_UserGroupReports', $data);	
	}	
	

	
	if (!in_array('plugin_nmidCreatePDF_GraphReports', $a_tables)) {
		// Create Graph Report Table
		$data = array();
		$data['columns'][] = array('name' => 'Id', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false, 'auto_increment' => true);
		$data['columns'][] = array('name' => 'ReportId', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false );
		$data['columns'][] = array('name' => 'local_graph_id', 'type' => 'mediumint(25)', 'NULL' => false);
		$data['columns'][] = array('name' => 'order', 'type' => 'mediumint(25)', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'group', 'type' => 'mediumint(25)', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'Description', 'type' => 'text', 'NULL' => true);
		$data['primary'] = 'Id';
		$data['type'] = 'MyISAM';
		$data['keys'][] = array('name' => 'ReportId',	'columns' => 'ReportId');
		$data['comment'] = 'CereusReporting Graph Reports';
		api_plugin_db_table_create ('nmidCreatePDF', 'plugin_nmidCreatePDF_GraphReports', $data);	
	}
	
	if (!in_array('plugin_nmidCreatePDF_MultiGraphReports', $a_tables)) {
		// Create MultiGraph Report Table
		$data = array();
		$data['columns'][] = array('name' => 'Id', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false, 'auto_increment' => true);
		$data['columns'][] = array('name' => 'ReportId', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false );
		$data['columns'][] = array('name' => 'order', 'type' => 'mediumint(25)', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'data', 'type' => 'text', 'NULL' => true);
		$data['columns'][] = array('name' => 'type', 'type' => 'text', 'NULL' => true);
		$data['primary'] = 'Id';
		$data['keys'][] = array('name' => 'ReportId',	'columns' => 'ReportId');
		$data['type'] = 'MyISAM';
		$data['comment'] = 'CereusReporting MultiGraph Reports';
		api_plugin_db_table_create ('nmidCreatePDF', 'plugin_nmidCreatePDF_MultiGraphReports', $data);	
	}
	
	if (!in_array('plugin_nmidCreatePDF_DSStatsReports', $a_tables)) {
		// Create DSStats Graph Report Table
		$data = array();
		$data['columns'][] = array('name' => 'Id', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false, 'auto_increment' => true);
		$data['columns'][] = array('name' => 'ReportId', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false );
		$data['columns'][] = array('name' => 'DSStatsGraph', 'type' => 'text', 'NULL' => false);
		$data['columns'][] = array('name' => 'order', 'type' => 'mediumint(25)', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'group', 'type' => 'mediumint(25)', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'Description', 'type' => 'text', 'NULL' => true);
		$data['primary'] = 'Id';
		$data['keys'][] = array('name' => 'ReportId',	'columns' => 'ReportId');
		$data['type'] = 'MyISAM';
		$data['comment'] = 'CereusReporting DSStats Reports';
		api_plugin_db_table_create ('nmidCreatePDF', 'plugin_nmidCreatePDF_DSStatsReports', $data);	
	}
	
	if (!in_array('plugin_nmidCreatePDF_ZenossReports', $a_tables)) {
		// Create DSStats Graph Report Table
		$data = array();
		$data['columns'][] = array('name' => 'Id', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false, 'auto_increment' => true);
		$data['columns'][] = array('name' => 'ReportId', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false );
		$data['columns'][] = array('name' => 'ZenossReport', 'type' => 'text', 'NULL' => false);
		$data['columns'][] = array('name' => 'order', 'type' => 'mediumint(25)', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'group', 'type' => 'mediumint(25)', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'Description', 'type' => 'text', 'NULL' => true);
		$data['primary'] = 'Id';
		$data['keys'][] = array('name' => 'ReportId',	'columns' => 'ReportId');
		$data['type'] = 'MyISAM';
		$data['comment'] = 'CereusReporting Zenooss Reports';
		api_plugin_db_table_create ('nmidCreatePDF', 'plugin_nmidCreatePDF_ZenossReports', $data);	
	}
    
	if (!in_array('plugin_nmidCreatePDF_Reports_Types', $a_tables)) {
		// Create Report type
		$data = array();
		$data['columns'][] = array('name' => 'TypeId', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false, 'auto_increment' => true);
		$data['columns'][] = array('name' => 'timeInSeconds', 'type' => 'varchar(255)', 'NULL' => false, 'default' => '0');  
		$data['columns'][] = array('name' => 'Description', 'type' => 'text', 'NULL' => true);
		$data['primary'] = 'TypeId';
		$data['type'] = 'MyISAM';
		$data['keys'][] = array('name' => 'timeInSeconds',	'columns' => 'timeInSeconds');
		$data['comment'] = 'CereusReporting Report Types';
		api_plugin_db_table_create ('nmidCreatePDF', 'plugin_nmidCreatePDF_Reports_Types', $data);	

		// Add Default Report types
		// special report types
		$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Reports_Types` (`timeInSeconds`, `Description`) VALUES ('0','On Demand');";
		$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Reports_Types` (`timeInSeconds`, `Description`) VALUES ('-1','1 Month');"; // calculated based on the month days
		$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Reports_Types` (`timeInSeconds`, `Description`) VALUES ('-2','1 Year');";  // calculated on the number of days of that year
		$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Reports_Types` (`timeInSeconds`, `Description`) VALUES ('-3', 'Yesterday');";
		$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Reports_Types` (`timeInSeconds`, `Description`) VALUES ('-4', 'Last Week');";
		$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Reports_Types` (`timeInSeconds`, `Description`) VALUES ('-5', 'Last Month');";
		$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Reports_Types` (`timeInSeconds`, `Description`) VALUES ('-6', 'Last Year');";
		// normal report types
		$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Reports_Types` (`timeInSeconds`, `Description`) VALUES ('3600','1 Hour');";
		$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Reports_Types` (`timeInSeconds`, `Description`) VALUES ('7200','2 Hour');";
		$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Reports_Types` (`timeInSeconds`, `Description`) VALUES ('14400','4 Hour');";
		$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Reports_Types` (`timeInSeconds`, `Description`) VALUES ('21600','6 Hour');";
		$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Reports_Types` (`timeInSeconds`, `Description`) VALUES ('43200','12 Hour');";
		$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Reports_Types` (`timeInSeconds`, `Description`) VALUES ('86400','1 Day');";
		$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Reports_Types` (`timeInSeconds`, `Description`) VALUES ('172800','2 Days');";
		$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Reports_Types` (`timeInSeconds`, `Description`) VALUES ('259200','3 Days');";
		$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Reports_Types` (`timeInSeconds`, `Description`) VALUES ('604800','1 Week');";
	}


	//if (!in_array('plugin_nmidCreatePDF_Graph_Groups', $a_tables)) {
	//	// Create Graph Groups Heading type
	//	$data = array();
	//	$data['columns'][] = array('name' => 'GroupId', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false, 'auto_increment' => true);
	//	$data['columns'][] = array('name' => 'Description', 'type' => 'text', 'NULL' => true);
	//	$data['primary'] = 'GroupId';
	//	$data['type'] = 'MyISAM';
	//	$data['keys'][] = array('name' => 'Description',	'columns' => 'Description');
	//	$data['comment'] = 'nmidCreatePDF Graph Groups';
	//	api_plugin_db_table_create ('nmidCreatePDF', 'plugin_nmidCreatePDF_Graph_Groups', $data);	
	//}
	//
	if (!in_array('plugin_nmidCreatePDF_Availability_Table', $a_tables)) {
		// 
		// Create Availability Report
		$data = array();
		$data['columns'][] = array('name' => 'Id', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false, 'auto_increment' => true);
		$data['columns'][] = array('name' => 'deviceId', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false );
		$data['columns'][] = array('name' => 'typeId', 'type' => 'varchar(255)', 'NULL' => false, 'default' => 'i');
		$data['columns'][] = array('name' => 'timeStamp', 'type' => 'varchar(255)', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'orig_total_polls', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false );
		$data['columns'][] = array('name' => 'orig_failed_polls', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false );
		$data['columns'][] = array('name' => 'total_polls', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false );
		$data['columns'][] = array('name' => 'failed_polls', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false );
		$data['columns'][] = array('name' => 'isLastEntry', 'type' => 'varchar(255)', 'NULL' => false, 'default' => '0');
		$data['primary'] = 'Id';
		$data['keys'][] = array('name' => 'deviceId',	'columns' => 'deviceId');
		$data['type'] = 'MyISAM';
		$data['comment'] = 'CereusReporting Availability Report Table';
		api_plugin_db_table_create ('nmidCreatePDF', 'plugin_nmidCreatePDF_Availability_Table', $data);	
		$sql[] = "ALTER TABLE `plugin_nmidCreatePDF_Availability_Table` ADD INDEX `timeStamp` (`timeStamp`), ADD INDEX `deviceId` (`deviceId`, `typeId`)";
	}
	
	if (!in_array('plugin_nmidCreatePDF_AvailabilityFailedPolls_Table', $a_tables)) {
		// 
		// Create Availability Report
		$data = array();
		$data['columns'][] = array('name' => 'Id', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false, 'auto_increment' => true);
		$data['columns'][] = array('name' => 'deviceId', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false );
		$data['columns'][] = array('name' => 'timeStamp', 'type' => 'varchar(255)', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'type', 'type' => 'varchar(255)', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'failed_polls', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false );
		$data['columns'][] = array('name' => 'ldid', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false );
		$data['primary'] = 'Id';
		$data['keys'][] = array('name' => 'deviceId',	'columns' => 'deviceId');
		$data['type'] = 'MyISAM';
		$data['comment'] = 'CereusReporting Availability Failed Polls Table';
		api_plugin_db_table_create ('nmidCreatePDF', 'plugin_nmidCreatePDF_AvailabilityFailedPolls_Table', $data);
		$sql[] = "ALTER TABLE `plugin_nmidCreatePDF_AvailabilityFailedPolls_Table` ADD INDEX `timeStamp` (`timeStamp`), ADD INDEX `deviceId` (`deviceId`), ADD INDEX `ldid` (`ldid`)";
	}
	
	//  $sql[] = "INSERT INTO `plugin_nmidCreatePDF_Availability_Types` (`comment`,`data`) VALUES ('hourly','h');";
	//	$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Availability_Types` (`comment`,`data`) VALUES ('daily','d');";
	//	$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Availability_Types` (`comment`,`data`) VALUES ('weekly','w');";
	//	$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Availability_Types` (`comment`,`data`) VALUES ('monthly','m');";
	//	$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Availability_Types` (`comment`,`data`) VALUES ('quarterly','q');";
	//	$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Availability_Types` (`comment`,`data`) VALUES ('yearly','y');";
	//	$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Availability_Types` (`comment`,`data`) VALUES ('initial','i');";
	//	$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Availability_Types` (`comment`,`data`) VALUES ('poll_interval','p');";
    
	if (!in_array('plugin_nmidCreatePDF_Availability_Change_Table', $a_tables)) {
		// 
		// Create Availability Change Report Table
		$data = array();
		$data['columns'][] = array('name' => 'Id', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false, 'auto_increment' => true);
		$data['columns'][] = array('name' => 'deviceId', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false );
		$data['columns'][] = array('name' => 'changeTypeId', 'type' => 'varchar(255)', 'NULL' => false, 'default' => '1');
		$data['columns'][] = array('name' => 'startTimeStamp', 'type' => 'varchar(255)', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'endTimeStamp', 'type' => 'varchar(255)', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'shortDescription', 'type' => 'text', 'NULL' => true);
		$data['columns'][] = array('name' => 'longDescription', 'type' => 'text', 'NULL' => true);
		$data['primary'] = 'Id';
		$data['keys'][] = array('name' => 'deviceId',	'columns' => 'deviceId');
		$data['type'] = 'MyISAM';
		$data['comment'] = 'CereusReporting Availability Change Report Table';
		api_plugin_db_table_create ('nmidCreatePDF', 'plugin_nmidCreatePDF_Availability_Change_Table', $data);	
	}
	
	if (!in_array('plugin_nmidCreatePDF_Availability_SLATimeFrame_Table', $a_tables)) {
		// 
		// Create Availability Change Report Table
		$data = array();
		$data['columns'][] = array('name' => 'Id', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false, 'auto_increment' => true);
		$data['columns'][] = array('name' => 'defaultDays', 'type' => 'varchar(255)', 'NULL' => false, 'default' => '1,2,3,4,5'); // Mon-Fri
		$data['columns'][] = array('name' => 'defaultStartTime', 'type' => 'varchar(255)', 'NULL' => false, 'default' => '08:00'); // 08:00
		$data['columns'][] = array('name' => 'defaultEndTime', 'type' => 'varchar(255)', 'NULL' => false, 'default' => '18:00');  // 18:00
		$data['columns'][] = array('name' => 'shortDescription', 'type' => 'text', 'NULL' => true);
		$data['columns'][] = array('name' => 'longDescription', 'type' => 'text', 'NULL' => true);
		$data['primary'] = 'Id';
		$data['type'] = 'MyISAM';
		$data['comment'] = 'CereusReporting Availability SLA TimeFrame Master Table';
		api_plugin_db_table_create ('nmidCreatePDF', 'plugin_nmidCreatePDF_Availability_SLATimeFrame_Table', $data);
        
		$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Availability_SLATimeFrame_Table` (`id`, `defaultDays`,`defaultStartTime`,`defaultEndTime`,`shortDescription`,`longDescription` ) ".
               "VALUES (1,'Mon,Tue,Wed,Thu,Fri,Sat,Sun','00:00','23:59','24x7','Default SLA TimeFrame');";
	}

	if (!in_array('plugin_nmidCreatePDF_Availability_SLATimeFrameItems_Table', $a_tables)) {
		// 
		// Create Availability Change Report Table
		$data = array();
		$data['columns'][] = array('name' => 'Id', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false, 'auto_increment' => true);
		$data['columns'][] = array('name' => 'slaTimeFrameId', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false );
		$data['columns'][] = array('name' => 'slaEnabled', 'type' => 'varchar(255)', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'startTimeStamp', 'type' => 'varchar(255)', 'NULL' => false, 'default' => '0'); 
		$data['columns'][] = array('name' => 'endTimeStamp', 'type' => 'varchar(255)', 'NULL' => false, 'default' => '0'); 
		$data['columns'][] = array('name' => 'description', 'type' => 'text', 'NULL' => true);
		$data['primary'] = 'Id';
		$data['keys'][] = array('name' => 'slaTimeFrameId',	'columns' => 'slaTimeFrameId');
		$data['type'] = 'MyISAM';
		$data['comment'] = 'CereusReporting Availability SLA TimeFrame Items Table';
		api_plugin_db_table_create ('nmidCreatePDF', 'plugin_nmidCreatePDF_Availability_SLATimeFrameItems_Table', $data);	
	}

	if (!in_array('plugin_nmidCreatePDF_Availability_Change_Type', $a_tables)) {
		// 
		// Create Availability Change Type Table
		$data = array();
		$data['columns'][] = array('name' => 'Id', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false, 'auto_increment' => true);
		$data['columns'][] = array('name' => 'shortName', 'type' => 'varchar(255)', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'decreaseAvailability', 'type' => 'varchar(255)', 'NULL' => false, 'default' => '0');
		$data['columns'][] = array('name' => 'Description', 'type' => 'text', 'NULL' => true);
		$data['primary'] = 'Id';
		$data['keys'][] = array('name' => 'shortName',	'columns' => 'shortName');
		$data['type'] = 'MyISAM';
		$data['comment'] = 'CereusReporting Availability Change Type Table';
		api_plugin_db_table_create ('nmidCreatePDF', 'plugin_nmidCreatePDF_Availability_Change_Type', $data);	

		// Add default entries
		$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Availability_Change_Type` (`shortName`,`Description`,`decreaseAvailability` ) VALUES ('planned','Planned downtime','0');";
		$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Availability_Change_Type` (`shortName`,`Description`,`decreaseAvailability` ) VALUES ('emergency','Emmergency downtime','1');";
		$sql[] = "INSERT INTO `plugin_nmidCreatePDF_Availability_Change_Type` (`shortName`,`Description`,`decreaseAvailability` ) VALUES ('other','Unplanned downtime','1');";
	}
	

	# now run all SQL commands
	if (!empty($sql)) {
		for ($a = 0; $a < count($sql); $a++) {
			$result = db_execute($sql[$a]);
		}
	}
}


function nmidCreatePDF_console_after () {
	global $config, $plugins;
    $dir = dirname(__FILE__);
	include_once($dir.'/functions.php');
	$current = nmidCreatePDF_version ();
	$current = $current['version'];
	$old = db_fetch_cell("SELECT version FROM plugin_config WHERE directory='nmidCreatePDF'");
	if ($current != $old)
		nmidCreatePDF_setup_table( $old );
		
	$timeLeft = getLicenseExpiry();
	if ( $timeLeft > 0 ) {
		if ( ( $timeLeft - time() ) < 345600 ) {
			if ( isLicenseExpired() ) {
				echo "<font size=+1 color=red><b>Attention: The trial license for CereusReporting expired on ".date("D M j G:i:s T Y",$timeLeft)."!</b></font>";
			}
			else {
				echo "<font size=+1 color=red><b>Attention: The license key for CereusReporting will expire on ".date("D M j G:i:s T Y",$timeLeft)."!</b></font>";
			}
		}
	}
}
	
function nmidCreatePDF_config_settings () {
	global $tabs, $settings;
    $dir = dirname(__FILE__);
	include_once($dir.'/functions.php');
	$tabs["nmid"] = "NMID";
	
	// Check for available ReportEngines
	$mpdf_dir = dirname(__FILE__) . '//ReportEngines//mpdf';
	$ar_ReportEngines = array ();
	$ar_ReportEngines["0"] = "FPDF";
	if ( is_dir( $mpdf_dir ) ) {
		$ar_ReportEngines["1"] = "mPDF";
	}
	$tcpdf_dir = dirname(__FILE__) . '//ReportEngines//tcpdf';
	if ( is_dir( $tcpdf_dir ) ) {
		$ar_ReportEngines["2"] = "TCPDF";
	}

	$sql = "SELECT
          `plugin_nmidCreatePDF_Availability_SLATimeFrame_Table`.`Id`,
          `plugin_nmidCreatePDF_Availability_SLATimeFrame_Table`.`shortDescription`
        FROM
          `plugin_nmidCreatePDF_Availability_SLATimeFrame_Table`";
	$result = mysql_query( $sql );

	$ar_slaTimeFrames = array ();
	$ar_slaTimeFrames["0"] = "none";
	while ( $row = mysql_fetch_assoc( $result ) ) {
	    $ar_slaTimeFrames[ $row['Id'] ] = $row['shortDescription'];
	}

	
	$licenseExpiry = '';
	$timeLeft = getLicenseExpiry();
	if ( $timeLeft > 0 ) {
		$licenseExpiry = date("D M j G:i:s T Y",$timeLeft);
	} else {
		$licenseExpiry = "never";
	}

	$temp = array();	
	if ( isPluginLicensed('ZENOSS') ) {
	    $temp_zenoss = array(
		"nmid_zenoss_header" => array(
		    "friendly_name" => "NMID - CereusReporting - Zenoss Addon  - ".EDITION." Edition - License Expiry Date : ".$licenseExpiry,
		    "method" => "spacer",
		    ),
		"nmid_zenoss_serverUrl" => array(
		    "friendly_name" => "Zenoss Base URL",
		    "description" => "The base Zenoss URL. Example: http://192.168.178.48:8080",
		    "method" => "textbox",
		    "max_length" => 255,
		    ),
		"nmid_zenoss_userId" => array(
		    "friendly_name" => "Zenoss UserID",
		    "description" => "The userid needed to logon to Zenoss.",
		    "method" => "textbox",
		    "max_length" => 255,
		    ),
		"nmid_zenoss_userPwd" => array(
		    "friendly_name" => "Zenoss User Password",
		    "description" => "Password used to connect to Zenoss. Please use a complex password.",
		    "method" => "textbox_password",
		    "max_length" => 20,
		    )
	    );
	    $temp = array_merge($temp, $temp_zenoss);
	}
	
	if ( ( EDITION == "CORPORATE" ) || ( isPluginLicensed( 'AVAILABILITY' ) ) || ( isSMBServer() ) ) {
	    $temp_availaiblity = array(
		"nmid_avail_header" => array(
		    "friendly_name" => "NMID - CereusReporting - Availability Addon  - ".EDITION." Edition - License Expiry Date : ".$licenseExpiry,
		    "method" => "spacer",
		    ),
		"nmid_avail_enabled" => array(
		    "friendly_name" => "Enable the Availability module",
		    "description" => "This box enables or disables the availability module",
		    "method" => "checkbox",
		    "max_length" => "255"
		    ),		
		"nmid_avail_winservice_enabled" => array(
		    "friendly_name" => "Enable the WinService state addon",
		    "description" => "This box enables or disables the Windows Service availability addon module",
		    "method" => "checkbox",
		    "max_length" => "255"
		    ),		
		"nmid_avail_globalSla" => array(
		    "friendly_name" => "Global SLA Threshold",
		    "description" => "The global SLA threshold. This can be overwritten on a per Device basis.",
		    "method" => "textbox",
			"default" => "95.99",
		    "max_length" => 10,
		    ),
		"nmid_avail_globalSlaTimeFrame" => array(
		    "friendly_name" => "Global SLA TimeFrame",
		    "description" => "The global SLA TimeFrame. This time frame will be used for calculating SLA measurements",
		    "method" => "drop_array",
		    "default" => "0",
		    "array" => $ar_slaTimeFrames
		    ),
		"nmid_avail_chartWidth" => array(
		    "friendly_name" => "Availability Chart Width",
		    "description" => "The width of the availability chart.",
		    "method" => "textbox",
			"default" => "900",
		    "max_length" => 4,
		    ),
		"nmid_avail_chartHeight" => array(
		    "friendly_name" => "Availability Chart Height",
		    "description" => "The height of the availability chart",
		    "method" => "textbox",
			"default" => "270",
		    "max_length" => 4,
		    ),
		"nmid_avail_maxDevices" => array(
		    "friendly_name" => "Availability Max Devices",
		    "description" => "The number of devices the combined availability chart can have on the Report. Will be ignored for the ABC separated view",
		    "method" => "textbox",
			"default" => "20",
		    "max_length" => 3,
		    ),
		"nmid_avail_sort_option" => array(
			"friendly_name" => "Grouping option",
			"description" => "Type of grouping used for the combined availability chart.",
			"method" => "drop_array",
			"default" => "devices",
			"array" => array(
				"devices" => "Device Count",
				"abc" => "ABC Grouping"
				)
			),
		"nmid_avail_font" => array(
			"friendly_name" => "Availability Font Type",
			"description" => "The font type to be used for the title.",
			"method" => "drop_array",
			"default" => "helvBI.ttf",
			"array" => array(
				"helvBI.ttf" => "Helvetia",
				"timesbi.ttf" => "Times"
				)
			),
		"nmid_avail_addTable" => array(
		    "friendly_name" => "Add availaibility table to tree view",
		    "description" => "This will add the availability data table after the tree view graph.",
		    "method" => "checkbox",
		    "max_length" => "255"
		    ),
		"nmid_avail_addDetailedTable" => array(
		    "friendly_name" => "Add detailed failed polls report table to tree view",
		    "description" => "This will add a failed polls report table after the tree view graph.",
		    "method" => "checkbox",
		    "max_length" => "255"
		    ),
		"nmid_avail_addGraph" => array(
		    "friendly_name" => "Add availaibility graph to report",
		    "description" => "This will add the availability graph to a report.",
		    "method" => "checkbox",
		    "max_length" => "255"
		    ),
		"nmid_avail_addWinServiceTable" => array(
		    "friendly_name" => "Add WinService availaibility table to tree view",
		    "description" => "This will add the WinService availability data table after the tree view graph.",
		    "method" => "checkbox",
		    "max_length" => "255"
		    ),
		"nmid_avail_addWinServiceGraph" => array(
		    "friendly_name" => "Add WinService availaibility graph to tree view",
		    "description" => "This will add the WinService availability graph to the tree view graph.",
		    "method" => "checkbox",
		    "max_length" => "255"
		    ),
		"nmid_avail_offSLATransparent" => array(
		    "friendly_name" => "Show Transparent area during non-SLA relevant time frames.",
		    "description" => "If enabled, non-SLA relevant areas will be transparent, otherwise the area will be shown as a semi transparentlight gray area.",
		    "method" => "checkbox",
		    "max_length" => "255"
		    ),
		"nmid_avail_useRRDstyle" => array(
		    "friendly_name" => "Use RRD style data aggregation",
		    "description" => "If enabled, data will be aggregated similiar to the RRD tool.",
		    "method" => "checkbox",
		    "max_length" => 255
		    ),
		"nmid_pollingInterval" => array(
			"friendly_name" => "Cacti Polling Interval being used",
			"description" => "The polling interval which is used for polling the hosts.",
			"method" => "drop_array",
			"default" => "poller",
			"array" => array(
				"5" => "5 Minute Polling",
				"1" => "1 Minute Polling"
				)
			),			
		"nmid_avail_PollMaxRawData" => array(
		    "friendly_name" => "Polling based (5min/1min)- Max Raw data to store",
		    "description" => "Time in seconds to store the data. ( e.g. 7 days = 60 seconds * 60 minutes * 24hours * 7 days = 604800 )",
		    "method" => "textbox",
			"default" => "86400",
		    "max_length" => 255,
		    ),			
		"nmid_avail_HourlyMaxRawData" => array(
		    "friendly_name" => "Hourly - Max Raw data to store",
		    "description" => "Number of hours to store the data.",
		    "method" => "textbox",
			"default" => "672",
		    "max_length" => 255,
		    ),			
		"nmid_avail_DailyMaxRawData" => array(
		    "friendly_name" => "Daily - Max Raw data to store",
		    "description" => "Number of days to store the data.",
		    "method" => "textbox",
			"default" => "365",
		    "max_length" => 255,
		    ),			
		"nmid_avail_WeeklyMaxRawData" => array(
		    "friendly_name" => "Weekly - Max Raw data to store",
		    "description" => "Number of weeks to store the data.",
		    "method" => "textbox",
			"default" => "500",
		    "max_length" => 255,
		    ),			
		"nmid_avail_MonthlyMaxRawData" => array(
		    "friendly_name" => "Monthly - Max Raw data to store",
		    "description" => "Number of months to store the data.",
		    "method" => "textbox",
			"default" => "96",
		    "max_length" => 255,
		    ),			
		"nmid_avail_YearlyMaxRawData" => array(
		    "friendly_name" => "Yearly - Max Raw data to store",
		    "description" => "Number of years to store the data.",
		    "method" => "textbox",
			"default" => "10",
		    "max_length" => 255,
		    ),			
		//"nmid_avail_maxRawData" => array(
		//    "friendly_name" => "Max Raw data to store",
		//    "description" => "Time in seconds to store the data. ( e.g. 7 days = 60 seconds * 60 minutes * 24hours * 7 days = 604800 )",
		//    "method" => "textbox",
		//    "max_length" => 255,
		//    ),			
		"nmid_avail_startTag" => array(
		    "friendly_name" => "Start tag",
		    "description" => "Start tag for the availability data display. This will be appended to the data set on the graph.",
		    "method" => "textbox",
			"default" => "Start",
		    "max_length" => 255,
		    ),			
		"nmid_avail_endTag" => array(
		    "friendly_name" => "End Tag",
		    "description" => "End tag for the availability data display. This will be appended to the data set on the graph.",
		    "method" => "textbox",
			"default" => "End",
		    "max_length" => 255,
		    ),			
	    );
	    $temp = array_merge($temp, $temp_availaiblity);
	}
	

	$temp_general = array(
            "nmid_pdfheader" => array(
				"friendly_name" => "NMID - CereusReporting - Report Definition",
				"method" => "spacer",
		    ),
            "nmid_pdf_margin_left" => array(
                "friendly_name" => "Margin to the left",
                "description" => "Sets the page margins for the new document.",
                "method" => "textbox",
				"default" => '5',
                "max_length" => 255,
                ),
            "nmid_pdf_margin_right" => array(
                "friendly_name" => "Margin to the right",
                "description" => "Sets the page margins for the new document.",
                "method" => "textbox",
				"default" => '5',
                "max_length" => 255,
                ),
            "nmid_pdf_margin_top" => array(
                "friendly_name" => "Margin to the top",
                "description" => "Sets the page margins for the new document.",
                "method" => "textbox",
				"default" => '30',
                "max_length" => 255,
                ),
            "nmid_pdf_margin_bottom" => array(
                "friendly_name" => "Margin to the bottom",
                "description" => "Sets the page margins for the new document.",
                "method" => "textbox",
				"default" => '25',
                "max_length" => 255,
                ),
			"nmid_pdffontname" => array(
                "friendly_name" => "Font Name",
                "description" => "Choose which font you want to use.",
                "method" => "drop_array",
                "default" => "Arial",
                "array" => array(
                    "Arial" => "Arial"
                    )
                ),		
            "nmid_pdffontsize" => array(
                "friendly_name" => "Header Font Size",
                "description" => "Choose which font size you want to have your header in.",
                "method" => "drop_array",
                "default" => "10",
                "array" => array(
                    "6" => "6",
                    "8" => "8",
                    "10" => "10",
                    "12" => "12",
                    "14" => "14"
                    )
                ),
            "nmid_pdfpagesize" => array(
                "friendly_name" => "Page Size",
                "description" => "Choose which page format you want to have your PDF reports in.",
                "method" => "drop_array",
                "default" => "A4",
                "array" => array(
                    "A3" => "A3",
                    "A4" => "A4",
                    "A5" => "A5",
                    "Letter" => "Letter",
                    "Legal" => "Legal"
                    )
                ),
    		"nmid_pdfpageorientation" => array(
                "friendly_name" => "Page Orientation",
                "description" => "Landscape or Portrait",
                "method" => "drop_array",
                "default" => "P",
                "array" => array(
                    "P" => "Portrait",
                    "L" => "Landscape"
                    )
                ),		
            "nmid_pdfgraphPerPage" => array(
                "friendly_name" => "Graph Format",
                "description" => "Choose the number of graphs to put on the page.",
                "method" => "drop_array",
                "default" => "0",
                "array" => array(
                    "0" => "Default",
                    "2x2" => "2 Graphs, 2 Columns"
                    //"4" => "4 Graphs",
                    //"8" => "8 Graphs"
                    )
                ),
			"nmid_settings_header" => array(
				"friendly_name" => "NMID - CereusReporting - General - ".EDITION." Edition - License Expiry Date : ".$licenseExpiry,
				"method" => "spacer",
		    ),
            "nmid_pdftitle" => array(
                "friendly_name" => "Report Title",
                "description" => "The title of the report. This will only be displayed if the selected tree item is not a header.",
                "method" => "textbox",
                "max_length" => 255,
                ),
            "nmid_pdfsubtitle" => array(
                "friendly_name" => "Report Subtitle",
                "description" => "The default sub-title of the report. Eg. 'Provided by your Support Team'",
                "method" => "textbox",
                "max_length" => 255,
                ),
            "nmid_pdffooter" => array(
                "friendly_name" => "Report Footer",
                "description" => "The default footer of the report.",
                "method" => "textbox",
                "max_length" => 255,
                ),		
            "nmid_pdfPrintHeaderFooter" => array(
                "friendly_name" => "Print Header/Footer to PDF",
                "description" => "Enables/Disabled the printing of the Header and Footer. Should be disabled when using a CoverPage/Template.",
                "method" => "checkbox",
                "max_length" => "255"
                ),
            "nmid_pdflogo" => array(
                "friendly_name" => "Report Logo",
                "description" => "The company logo you want to be displayed on the PDF report. The default logo is images/default_logo.png. Needs to be a PNG file.",
                "method" => "textbox",
                "max_length" => 255,
                ),
    		"nmid_pdfUserHostname" => array(
                "friendly_name" => "Use 'HOSTNAME(IP)' in host only reports",
                "description" => "Displays 'Report for host hostname(a.b.c.d)' instead of the default report title",
                "method" => "checkbox",
                "max_length" => "255"
                ),
            "nmid_pdfSetLinks" => array(
                "friendly_name" => "Graphs link back to cacti",
                "description" => "A click on a graph in the PDF Report links back to the cacti page for that graph",
                "method" => "checkbox",
                "max_length" => "255"
                ),
            "nmid_pdfCactiServerUrl" => array(
                "friendly_name" => "Cacti Host/Server URL",
                "description" => "The Cacti Host/Server URL to be used in the graph links",
                "method" => "textbox",
                "max_length" => 255,
                ),
            //"nmid_pdfProgressBar" => array(
            //    "friendly_name" => "Show Progress bar when creating report",
            //    "description" => "Displayes a progressbar with the status of the report generation",
            //    "method" => "checkbox",
            //    "max_length" => "255"
            //    ),
            //"nmid_wsurl" => array(
            //    "friendly_name" => "WebService URL",
            //    "description" => "for nmidSmokeping graphs only. Url to the webservice: http://path/to/plugins/nmidWebService/webservice.php?wsdl",
            //    "method" => "textbox",
            //    "max_length" => 255,
            //    ),
            "nmid_phppath" => array(
                "friendly_name" => "PHP binary path",
                "description" => "Full Path to the php binary. You need to define the full path to php e.g '/usr/bin/php'.",
                "method" => "textbox",
				"default" => read_config_option('path_php_binary'),
                "max_length" => 255,
                ),
            "nmid_archiveDir" => array(
                "friendly_name" => "Archive Directory",
                "description" => "Archive directory for storing the PDF Reports.",
                "method" => "textbox",
				"default" => "archive",
                "max_length" => 255,
                ),
            "nmid_gzipPath" => array(
                "friendly_name" => "GZip binary path",
                "description" => "Path to the GZip binary. Archived reports will be gziped if this is set.",
                "method" => "textbox",
                "max_length" => 255,
                ),
//            "nmid_UpdateDir" => array(
//                "friendly_name" => "NMID Update Download path",
//                "description" => "Updates will be downloaded to this directory.",
//                "method" => "textbox",
//				"default" => "updates",
//                "max_length" => 255,
//                ),			
            "nmid_pdfscheduletype" => array(
                "friendly_name" => "Scheduler being used",
                "description" => "The poller is fine for small reports, but it is still recommended to use cron or windows scheduling.",
                "method" => "drop_array",
                "default" => "poller",
                "array" => array(
                    "poller" => "Poller",
					"cron" => "Cron"
                    )
                ),		
            "nmid_pdfthreads" => array(
                "friendly_name" => "Parallel Threads for Graph Rertieval",
                "description" => "The number of parallel processes for retrieving/generating the graphs for the PDF report.",
                "method" => "drop_array",
                "default" => "1",
                "array" => array(
                    "1" => "none",
					"2" => "2 Threads",
					"4" => "4 Threads",
					"10" => "10 Threads",
					"20" => "20 Threads",
					"40" => "40 Threads"
                    )
                ),
            "nmid_pdf_debug" => array(
                "friendly_name" => "Debuging mode",
                "description" => "Enable/Disable the debug mode for defined/on-demand reports ( Enable: Do not delete tmp files ).",
                "method" => "drop_array",
                "default" => "0",
                "array" => array(
                    "0" => "Disabled",
		    "1" => "Enabled"
                    )
                ),				
            "nmid_pdf_type" => array(
                "friendly_name" => "PDF Module to use",
                "description" => "Choose which PDF Engine you want to use.",
                "method" => "drop_array",
                "default" => "0",
                "array" => $ar_ReportEngines
                )
	);
	$temp = array_merge($temp, $temp_general);

		// Unicode Support for mPDF
		if ( is_dir( $mpdf_dir ) ) {
			$temp["nmid_pdfUseUnicode"] = array(
                "friendly_name" => "Use Unicode",
                "description" => "Unicode support will increase PDF filesize and processing time.<br><i>Only supported with the mPDF Engine</i>",
                "method" => "checkbox",
                "max_length" => "255"
            );
			$temp["nmid_pdfUnicodeFontSet"] = array(
                "friendly_name" => "Unicode FontSet",
                "description" => "FontSet to be used.<br><i>Only supported with the mPDF Engine</i>",
                "method" => "drop_array",
                "default" => "0",
                "array" => array(
                    "" => "Western European languages (English, Italian, German)",
                    "iso-8859-2" => "iso8859-2 - Central and Eastern European (Polish, Croatian, Czech, Slovak, Slovenian, Serbian, and Hungarian)",
                    "win-1251" => "win-1251 - Cyrillic (Russian, Bulgarian, Serbian, Macedonian and Bulgarian",
                    "iso-8859-4" => "iso-8859-4 - Baltic (Estonian, Latvian, Lithuanian, Greenlandic)",
					"iso-8859-7" => "iso-8859-7 - Greek language (monotonic orthography)",
					"iso-8859-9" => "iso-8859-9 - Latin-5 (Turkish, Kurdish)",
					"SJIS" => "SJIS - Japanese",
					"GBK" => "GBK - Chinese - Simplified",
					"BIG5" => "BIG5 - Chinese - Traditional",
					"UHC" => "UHC - Korean",
					"UTF-8" => "UTF-8 - Any CJK language"
                )	
            );
	}
		

        if (isset($settings["nmid"]))
                $settings["nmid"] = array_merge($settings["nmid"], $temp);
        else
                $settings["nmid"] = $temp;

}


function nmidCreatePDF_tree_after ($param)
{
	global $config, $database_default;
    preg_match("/^(.+),(\d+)$/",$param,$hit);
	include_once($config["library_path"] . "/adodb/adodb.inc.php");
	include_once($config["library_path"] . "/database.php");
    $dir = dirname(__FILE__);
	include_once($dir.'/functions.php');

	if ( isLicenseExpired() ) {
		return;
	}
	if ( isServerLicensed() == FALSE ) {
		return;
	}
	$startTime = get_current_graph_start();
	$endTime = get_current_graph_end();	

	if (api_user_realm_auth('nmidCreatePDF_AvailabilityChart.php')) {
		if ( ( EDITION == "CORPORATE" ) || ( isPluginLicensed( 'AVAILABILITY' ) ) || ( isSMBServer() ) ) {
			if ( isset ( $hit[1] ) ){
				// We skip hosts for now.			
			}
			else {
				// So we're in a leaf
				$tree_id = $_REQUEST['tree_id'];
				$host_leaf_id = $_REQUEST['leaf_id'];

				// We now need to get the real host_id
				$leaf_title = db_fetch_cell("select title from graph_tree_items where id=$host_leaf_id");
				$host_id = 0;
				if ( preg_match("@\[NMIDWM\-(.*)\]\s(.*)@" , $leaf_title, $matches) ) {
					$weathermap_id = $matches[1];
					$dir = dirname(__FILE__);
					$filename = $dir.'/../weathermap/output/'.$weathermap_id.'.html';
					$handle = fopen($filename,"r");
					$contents = fread($handle, filesize($filename));
					fclose($handle);
					$contents = preg_replace('@weathermap-cacti-plugin.php@',$config['url_path'].'/plugins/weathermap/weathermap-cacti-plugin.php',$contents);
					$url = $config['url_path'] . 'plugins/weathermap/weathermap-cacti-plugin.php?action=viewimage&id='.$weathermap_id;
					if ( readPluginStatus('nmidWeb2') ) {
						print "<div class='sidebarBox portlet' id='item-av01'>\n";
						print "<div class='portlet-header'>Weathermap Report</div>\n";
						print "<div class='guideListing portlet-content'><center>\n";
					}
					else {
						?>
						<tr bgcolor='#6d88ad'>
							<tr bgcolor='#a9b7cb'>
								<td colspan='3' class='textHeaderDark'>
									<strong>Weathermap Report
								</td>
							</tr>			
							<tr align='center' style='background-color: #f9f9f9;'>
								<td align='center'>
								<div id="overDiv" style="position:absolute; visibility:hidden; z-index:1000;"></div>
								<script type="text/javascript" src="<?php echo $config['url_path'].'/plugins/weathermap/'; ?>overlib.js"><!-- overLIB (c) Erik Bosrup --></script> 
								<?php echo $contents; ?>
						<?php
					}
				}

				if ( preg_match("@\[NMIDWS\-(.*)\]\s(.*)@" , $leaf_title, $matches) ) {
					$my_leaf_id = $matches[1];
					if ( readPluginStatus('nmidWeb2') ) {
						print "<div class='sidebarBox portlet' id='item-av01'>\n";
						print "<div class='portlet-header'>Windows Services Report</div>\n";
						print "<div class='guideListing portlet-content'><center>\n";
					}
					else {
						?>
						<tr bgcolor='#6d88ad'>
							<tr bgcolor='#a9b7cb'>
								<td colspan='3' class='textHeaderDark'>
									<strong>Windows Services Report
								</td>
							</tr>			
							<tr align='center' style='background-color: #f9f9f9;'>
								<td align='center'>
								<!-- MAIN CONTENT HERE -->
						<?php
								print "	<table width='1' cellpadding='0'>\n";
								print "		<tr>\n";
								print "			<td valign='top' style='padding: 3px;' class='noprint'>\n";
								print "				<img src='". $config['url_path'] . 'plugins/nmidCreatePDF/cereusReporting_winserviceAvailabilityChart.php?spaceLeft=300&tree_id='.$tree_id.'&leaf_id='.$my_leaf_id.'&startTime='.$startTime.'&endTime='.$endTime.'&mode=time&data=p'."' border='0'>\n";
								print "			</td>\n";
								print "			<td valign='top' style='padding: 3px;' class='noprint'>";
								if (api_user_realm_auth('nmidCreatePDF_GenerateReports.php')) {
									print " 	    <input onClick=\"setData('avwsc_".$tree_id."_".$my_leaf_id."');\" type=checkbox id='avwsc_".$tree_id."_".$my_leaf_id."' name='avwsc_".$tree_id."_".$my_leaf_id."' value='".$tree_id."_".$my_leaf_id."'><br>";
								}
								print "         </td>";
								print "		</tr>\n";
								print "</table>\n";						
					}
				}

				if ( preg_match("@\[NMIDTH\-(.*)\]\s(.*)@" , $leaf_title, $matches) ) {
					$dataType = $matches[1];
					if ( readPluginStatus('nmidWeb2') ) {
						print "<div class='sidebarBox portlet' id='item-av01'>\n";
						print "<div class='portlet-header'>Threshold Report</div>\n";
						print "<div class='guideListing portlet-content'><center>\n";
					}
					else {
						?>
						<tr bgcolor='#6d88ad'>
							<tr bgcolor='#a9b7cb'>
								<td colspan='3' class='textHeaderDark'>
									<strong>Threshold Report
								</td>
							</tr>			
							<tr align='center' style='background-color: #f9f9f9;'>
								<td align='center'>
						<?php
					}					
					if ( preg_match("@^leaf@", $dataType ) )  {
						// Leaf					
					}
					elseif ( preg_match("@^tree@", $dataType ) ) {
					    // Tree
					}
					else {
						if ( preg_match("@^host(.*)@", $dataType, $hostMatches ) ) {
							$host_id = $hostMatches[1];
							// Host
							$a_hostTholdStates = db_fetch_assoc("
								SELECT 
									FROM_UNIXTIME(`time`) as time,
									host_id,
									threshold_value,
									current,
									`status`,
									`description`
								FROM
								   `plugin_thold_log`
								WHERE 
									host_id = $host_id
								ORDER BY
									time
							");
							
							print "<table width=100%>\n";
							foreach ( $a_hostTholdStates as $a_hostTholdState ) {
								print "<tr>".
									"<td>".$a_hostTholdState['host_id']."</td>".
									"<td>".$a_hostTholdState['time']."</td>".
									"<td>".$a_hostTholdState['threshold_value']."</td>".
									"<td>".$a_hostTholdState['current']."</td>".
									"<td>".$a_hostTholdState['status']."</td>".
									"<td>".$a_hostTholdState['description']."</td>".
								"</tr>\n";
							}								
							print "</table>\n";
						}
					}						
					if ( readPluginStatus('nmidWeb2') ) {
						print "</center></div></div>";
					} else {
						print "</td></tr></tr>";
					}
				}
			}
		}
	}	
	
	if ( read_config_option('nmid_avail_enabled') ) {
		$globalSLA = readConfigOption('nmid_avail_globalSla');
		if (api_user_realm_auth('nmidCreatePDF_AvailabilityChart.php')) {
			if ( ( EDITION == "CORPORATE" ) || ( isPluginLicensed( 'AVAILABILITY' ) ) || ( isSMBServer() ) ) {
				// Availability Reports are only available in Pro and Corporate Edition
				$tree_id = $_REQUEST['tree_id'];
				$host_leaf_id = $_REQUEST['leaf_id'];
				if ( isset ( $hit[1] ) )
				{    
					// no hostname set
					$host_name = $hit[1];
					$host_leaf_id = $hit[2];
				
					$host_id = db_fetch_cell("select host_id from graph_tree_items where id=$host_leaf_id");
					$host_sla = db_fetch_cell("select nmid_host_sla from host where id=$host_id");
					$slaValue = $globalSLA;
					$slaString = '';
					if ( $host_sla > 0 ) {
						$slaValue = $host_sla;
					}			
					if ( readPluginStatus('nmidWeb2') ) {
						print "<div class='sidebarBox portlet' id='item-av01'>\n";
						print "<div class='portlet-header'>Graph Template:</strong> Availability Chart</div>\n";
						print "<div class='guideListing portlet-content'><center>\n";
					}
					else {
					?>
					<tr bgcolor='#6d88ad'>
						<tr bgcolor='#a9b7cb'>
							<td colspan='3' class='textHeaderDark'>
								<strong>Graph Template:</strong> Availability Chart (external)
							</td>
						</tr>			
						<tr align='center' style='background-color: #f9f9f9;'>
							<td align='center'>
					<?php
					}
					print "	<table width='1' cellpadding='0'>\n";
					print "		<tr>\n";
					print "			<td valign='top' style='padding: 3px;' class='noprint'>\n";
					print "				<img src='". $config['url_path'] . 'plugins/nmidCreatePDF/cereusReporting_serverAvailabilityChart.php?tree_id='.$tree_id.'&leaf_id='.$host_leaf_id.'&startTime='.$startTime.'&endTime='.$endTime.'&mode=time&data=p'."' border='0'>\n";
					print "			</td>\n";
					print "			<td valign='top' style='padding: 3px;' class='noprint'>";
					if (api_user_realm_auth('nmidCreatePDF_GenerateReports.php')) {
						print " 	    <input onClick=\"setData('avc_".$tree_id."_".$host_leaf_id."');\" type=checkbox id='avc_".$tree_id."_".$host_leaf_id."' name='avc_".$tree_id."_".$host_leaf_id."' value='".$tree_id."_".$host_leaf_id."'><br>";
					}
					print "         </td>";
					print "		</tr>\n";
					print "</table>\n";
	
					if ( read_config_option('nmid_avail_addTable') ) {
						list ( $availability, $totalPolls, $failedPolls ) = get_device_availability( $host_id, $startTime -1, $endTime +1 );
			
						print "<table>\n";
						print "	<tr>\n";
						print " 	<th style='border-bottom: 2px solid #000000;'>Total Polls</th>\n";
						print " 	<th style='border-bottom: 2px solid #000000;'>Failed Polls</th>\n";
						print " 	<th style='border-bottom: 2px solid #000000;'>Availability</th>\n";
						print " 	<th style='border-bottom: 2px solid #000000;'>".$slaString." SLA</th>\n";
						print "	</tr>\n";
						print "	<tr>\n";
						print " 	<td align=center>".number_format($totalPolls)."</td>\n";
						print " 	<td style='border-left: 1px solid #000000;' align=center>".number_format($failedPolls)."</td>\n";
						$fontColor = '#007700';
						if ( $availability < $slaValue ) {
							$fontColor = '#aa0000';
						}
						print " 	<td style='border-left: 1px solid #000000;' align=center><font color=".$fontColor."><b>".number_format($availability,2)."%</b></font></td>\n";
						print " 	<td style='border-left: 1px solid #000000;' align=center>".number_format($slaValue,2)."%</td>\n";
						print "	</tr>\n";
						print "</table>\n";
					}
					if ( readPluginStatus('nmidWeb2') ) {
						print "</center></div></div>";
					} else {
						print "</td></tr></tr>";
					}
					
				}
				else {
					if ( nmidCreatePDF_getHostCountFromLeaf($host_leaf_id, $tree_id) > 0 ) {
						// no hostname set
						if ( readPluginStatus('nmidWeb2') ) {
							print "<div class='sidebarBox portlet' id='item-av01'>\n";
							print "<div class='portlet-header'>Graph Template:</strong> Availability Chart</div>\n";
							print "<div class='guideListing portlet-content'><center>\n";
						}
						else {
						?>
						<tr bgcolor='#6d88ad'>
							<tr bgcolor='#a9b7cb'>
								<td colspan='3' class='textHeaderDark'>
									<strong>Graph Template:</strong> Availability Chart (external)
								</td>
							</tr>			
							<tr align='center' style='background-color: #f9f9f9;'>
								<td align='center'>
						<?php
						}
						print "	<table width='1' cellpadding='0'>\n";
						print "		<tr>\n";
						print "			<td valign='top' style='padding: 3px;' class='noprint'>\n";
						print "				<img src='". $config['url_path'] . 'plugins/nmidCreatePDF/cereusReporting_serverAvailabilityChart.php?tree_id='.$tree_id.'&leaf_id='.$host_leaf_id.'&startTime='.$startTime.'&endTime='.$endTime.'&mode=time&data=p'."' border='0'>\n";
						print "			</td>\n";
						print "			<td valign='top' style='padding: 3px;' class='noprint'>";
						if (api_user_realm_auth('nmidCreatePDF_GenerateReports.php')) {
							print " 	    <input onClick=\"setData('avc_".$tree_id."_".$host_leaf_id."');\" type=checkbox id='avc_".$tree_id."_".$host_leaf_id."' name='avc_".$tree_id."_".$host_leaf_id."' value='".$tree_id."_".$host_leaf_id."'><br>";
						}
						print "         </td>";
						print "		</tr>\n";
						print "</table>\n";
					}
				}
				
							
				// Windows Service Status
				if ( isset ( $hit[1] ) ){
					// hostname set
					$host_name = $hit[1];
					$host_leaf_id = $hit[2];
					$startTime = get_current_graph_start();
					$endTime = get_current_graph_end();
					$host_id = db_fetch_cell("select host_id from graph_tree_items where id=$host_leaf_id");
					$host_sla = db_fetch_cell("select nmid_host_sla from host where id=$host_id");
					$slaValue = $globalSLA;
					if ( $host_sla > 0 ) {
						$slaValue = $host_sla;
					}

					if ( readPluginStatus("storeLastPoll") ) {
						$hostHasWinServices = FALSE;
						if ( read_config_option("nmid_avail_addWinServiceTable") ) {
							// Check for Windows Services
							$a_hostServiceStates = db_fetch_assoc("
								SELECT
									`data_template_data`.local_data_id,
									`data_template_data`.name_cache
								FROM
									`data_template_data`,
									`data_local`
								WHERE
									`data_local`.id = `data_template_data`.local_data_id
								AND
									`data_local`.host_id = ".$host_id."
								AND
								   `data_template_data`.data_source_path LIKE '%service_state%'
							");
							
							foreach ( $a_hostServiceStates as $a_hostServiceState ) {
								$s_timeframes_sql = "
										SELECT
											sum(failed_polls) as failed_polls
										FROM
											plugin_nmidCreatePDF_AvailabilityFailedPolls_Table
										WHERE
											timeStamp > $startTime
										AND
											timeStamp < $endTime
										AND
											ldid = ".$a_hostServiceState['local_data_id']."
									";
								list ( $availability, $totalPolls, $hostFailedPolls ) = get_device_availability( $host_id, $startTime, $endTime );
								$failedPolls = db_fetch_cell( $s_timeframes_sql ) + $hostFailedPolls;
								
								$availability = 100;
								if ( $totalPolls > 0 ) {
									$availability = ( 100 * ($totalPolls - $failedPolls) ) / $totalPolls;
								}	
									
								if ( readPluginStatus('nmidWeb2') ) {
									print "<div class='sidebarBox portlet' id='item-av01'>\n";
									print "<div class='portlet-header'>Graph Template:</strong>  ".$a_hostServiceState['name_cache']." SLA Table</div>\n";
									print "<div class='guideListing portlet-content'><center>\n";
								}
								else {
								?>
								<tr bgcolor='#6d88ad'>
									<tr bgcolor='#a9b7cb'>
										<td colspan='3' class='textHeaderDark'>
											<strong>Graph Template:</strong> <?php echo $a_hostServiceState['name_cache']; ?> SLA Table
										</td>
									</tr>			
									<tr align='center' style='background-color: #f9f9f9;'>
										<td align='center'>
								<?php
								}
								$hostHasWinServices = TRUE;
								print "<table>\n";
								print "	<tr>\n";
								print " 	<th style='border-bottom: 2px solid #000000;'>Total Polls</th>\n";
								print " 	<th style='border-bottom: 2px solid #000000;'>Failed Polls</th>\n";
								print " 	<th style='border-bottom: 2px solid #000000;'>Availability</th>\n";
								print " 	<th style='border-bottom: 2px solid #000000;'>".$slaString." SLA</th>\n";
								print "	</tr>\n";
								print "	<tr>\n";
								print " 	<td align=center>".number_format($totalPolls)."</td>\n";
								print " 	<td style='border-left: 1px solid #000000;' align=center>".number_format($failedPolls)."</td>\n";
								$fontColor = '#007700';
								if ( $availability < $slaValue ) {
									$fontColor = '#aa0000';
								}
								print " 	<td style='border-left: 1px solid #000000;' align=center><font color=".$fontColor."><b>".number_format($availability,2)."%</b></font></td>\n";
								print " 	<td style='border-left: 1px solid #000000;' align=center>".number_format($slaValue,2)."%</td>\n";
								print "	</tr>\n";
								print "</table>\n";						
	
								if ( readPluginStatus('nmidWeb2') ) {
									print "</center></div></div>";
								} else {
									print "</td></tr></tr>";
								}
							} // end foreach host win service states
						}
						
						if ( read_config_option("nmid_avail_addWinServiceGraph") ) {
							if ( $hostHasWinServices ) {
								if ( readPluginStatus('nmidWeb2') ) {
									print "<div class='sidebarBox portlet' id='item-av01'>\n";
									print "<div class='portlet-header'>Graph Template:</strong>  Win Services Availability Table</div>\n";
									print "<div class='guideListing portlet-content'><center>\n";
								}
								else {
								?>
								<tr bgcolor='#6d88ad'>
									<tr bgcolor='#a9b7cb'>
										<td colspan='3' class='textHeaderDark'>
											<strong>Graph Template:</strong> <?php echo $a_hostServiceState['name_cache']; ?> SLA Table
										</td>
									</tr>			
									<tr align='center' style='background-color: #f9f9f9;'>
										<td align='center'>
								<?php
								}
								
								print "	<table width='1' cellpadding='0'>\n";
								print "		<tr>\n";
								print "			<td valign='top' style='padding: 3px;' class='noprint'>\n";
								print "				<img src='". $config['url_path'] . 'plugins/nmidCreatePDF/cereusReporting_winserviceAvailabilityChart.php?spaceLeft=300&tree_id='.$tree_id.'&leaf_id='.$host_leaf_id.'&startTime='.$startTime.'&endTime='.$endTime.'&mode=time&data=p'."' border='0'>\n";
								print "			</td>\n";
								print "			<td valign='top' style='padding: 3px;' class='noprint'>";
								if (api_user_realm_auth('nmidCreatePDF_GenerateReports.php')) {
									print " 	    <input onClick=\"setData('avwsc_".$tree_id."_".$host_leaf_id."');\" type=checkbox id='avwsc_".$tree_id."_".$host_leaf_id."' name='avwsc_".$tree_id."_".$host_leaf_id."' value='".$tree_id."_".$host_leaf_id."'><br>";
								}
								print "         </td>";
								print "		</tr>\n";
								print "</table>\n";
							}
						}						
					}
				}
				else {
					if ( nmidCreatePDF_getHostCountFromLeaf($host_leaf_id, $tree_id) > 0 ) {
						// no hostname set
						if ( read_config_option("nmid_avail_addWinServiceGraph") ) {
							if ( readPluginStatus('nmidWeb2') ) {
								print "<div class='sidebarBox portlet' id='item-av01'>\n";
								print "<div class='portlet-header'>Graph Template:</strong> Availability Chart</div>\n";
								print "<div class='guideListing portlet-content'><center>\n";
							}
							else {
							?>
							<tr bgcolor='#6d88ad'>
								<tr bgcolor='#a9b7cb'>
									<td colspan='3' class='textHeaderDark'>
										<strong>Graph Template:</strong>  Win Services Availability Chart (external)
									</td>
								</tr>			
								<tr align='center' style='background-color: #f9f9f9;'>
									<td align='center'>
							<?php
							}
								print "	<table width='1' cellpadding='0'>\n";
								print "		<tr>\n";
								print "			<td valign='top' style='padding: 3px;' class='noprint'>\n";
								print "				<img src='". $config['url_path'] . 'plugins/nmidCreatePDF/cereusReporting_winserviceAvailabilityChart.php?spaceLeft=300&tree_id='.$tree_id.'&leaf_id='.$host_leaf_id.'&startTime='.$startTime.'&endTime='.$endTime.'&mode=time&data=p'."' border='0'>\n";
								print "			</td>\n";
								print "			<td valign='top' style='padding: 3px;' class='noprint'>";
								if (api_user_realm_auth('nmidCreatePDF_GenerateReports.php')) {
									print " 	    <input onClick=\"setData('avwsc_".$tree_id."_".$host_leaf_id."');\" type=checkbox id='avwsc_".$tree_id."_".$host_leaf_id."' name='avwsc_".$tree_id."_".$host_leaf_id."' value='".$tree_id."_".$host_leaf_id."'><br>";
								}
								print "         </td>";
								print "		</tr>\n";
								print "</table>\n";
						}
					}
				}				
			}
		}
	}
    return $param;
}


function nmidCreatePDF_config_arrays () {
	global $user_auth_realms, $user_auth_realm_filenames, $menu, $config;
    $dir = dirname(__FILE__);
	include_once($dir.'/functions.php');
	$temp =array();

	$temp_header = array(
		"plugins/nmidCreatePDF/nmidCreatePDF_Reports.php" => "Manage Reports",
	);
	$temp = array_merge($temp, $temp_header);

	// Plugins Section
	if ( ( EDITION == "CORPORATE" ) || ( isPluginLicensed( 'ARCHIVING' ) ) || ( isSMBServer() ) ) {
		$temp_arch = array(
			"plugins/nmidCreatePDF/nmidCreatePDF_Archive.php" => "Manage Archive",
			"plugins/nmidCreatePDF/nmidCreatePDF_ArchiveUserGroups.php" => " - User Groups"
		);
		$temp = array_merge($temp, $temp_arch);
	}
	// Plugins Section
	if ( ( EDITION == "CORPORATE" ) || ( isPluginLicensed( 'SCHEDULER' ) ) || ( isSMBServer() ) ) {
		$temp_schdl = array(
			"plugins/nmidCreatePDF/nmidCreatePDF_scheduler.php" => "Manage Report Schedule"
		);
		$temp = array_merge($temp, $temp_schdl);
	}
	if ( ( EDITION == "CORPORATE" ) || ( isPluginLicensed( 'AVAILABILITY' ) ) || ( isSMBServer() ) ) {
		$temp_avail = array(
			"plugins/nmidCreatePDF/nmidCreatePDF_Availability_DowntimeSchedule.php" => "Availability",
			"plugins/nmidCreatePDF/nmidCreatePDF_Availability_SLATimeFrame.php" => " - SLA Times",
			"plugins/nmidCreatePDF/nmidCreatePDF_Availability_SLATimeFrameItem.php" => " - SLA Times Items"
		);
		$temp = array_merge($temp, $temp_avail);
	}

	$temp_footer = array(
		"plugins/nmidCreatePDF/nmidCreatePDF_Backup.php" => "Backup/Restore",
		"plugins/nmidCreatePDF/nmidCreatePDF_debug.php" => "Debug Info"
		//"plugins/nmidCreatePDF/nmidCreatePDF_support.php" => "Support"
	);
	$temp = array_merge($temp, $temp_footer);	    
        
    
	if (isset($menu["NMID"]))
		$menu["NMID"] = array_merge($temp, $menu["NMID"]);
	else
		$menu["NMID"] = $temp;
}

function nmidCreatePDF_version () {
	return array( 'name' 	=> 'nmidCreatePDF',
			'version' 	=> '1.83.42',
			'longname'	=> 'NMID CereusReporting Plugin',
			'author'	=> 'Thomas Urban',
			'homepage'	=> 'http://www.urban-software.de',
			'email'		=> 'nmid@urban-software.de',
			'url'		=> 'http://www.urban-software.de/nmid/CreatePDF/versions.php'
			);
}

function nmidCreatePDF_setup_table ( $old_version ) {
    global $config;
	$dir = dirname(__FILE__);
	include_once($dir.'/functions.php');
	
	nmidCreatePDF_setup_table_new();
	$version_info = nmidCreatePDF_version();
	db_execute('UPDATE plugin_config SET version = "' . $version_info['version'] . '" WHERE directory = "nmidCreatePDF"');

    api_plugin_register_realm('nmidCreatePDF', 'nmidCreatePDF_AvailabilityChart.php', 'NMID - View Availability Charts', 1199);
    api_plugin_register_realm('nmidCreatePDF', 'nmidCreatePDF_userArchive.php', 'NMID - View Archived Reports', 1200);

	// get minor and major version number
	preg_match("@(\d+)\.(\d+).(\d+)@", $old_version, $version_match );
	
	$version_major = $version_match[1];
	$version_minor = $version_match[2];
	$version_build = $version_match[3];

	//cacti_log("CEREUSREPORTING Version Info: Major[$version_major] - Minor[$version_minor]");
	//cacti_log("CEREUSREPORTING Processing Database Updates");
	
	
	if ( $version_major < 1 ) {
		api_plugin_register_hook('nmidCreatePDF', 'tree_after', 'nmidCreatePDF_tree_after', 'setup.php');
		api_plugin_register_hook('nmidCreatePDF', 'api_device_save', 'nmidCreatePDF_api_device_save', 'setup.php');
	}		
	if ( ( $version_major < 2 ) && ( $version_minor < 16 ) ) {
        api_plugin_register_realm('nmidCreatePDF', 'nmidCreatePDF_addZenossReport.php,addToZenossReport.php,nmidCreatePDF_orderZenossReports.php', 'NMID - Manage Zenoss Reports', 1198);
    }
	if ( ( $version_major < 2 ) && ( $version_minor < 51 ) ) {
        $sql = "INSERT INTO `plugin_nmidCreatePDF_Availability_SLATimeFrame_Table` (`id`, `defaultDays`,`defaultStartTime`,`defaultEndTime`,`shortDescription`,`longDescription` ) ".
               "VALUES (1,'Mon,Tue,Wed,Thu,Fri,Sat,Sun','00:00','23:59','24x7','Default SLA TimeFrame');";
        db_execute( $sql );
    }
	if ( ( $version_major < 2 ) && ( $version_minor < 56 ) ) {
		api_plugin_db_add_column ('nmidCreatePDF', 'plugin_nmidCreatePDF_Archives', array('name' => 'UserGroupId', 'type' => 'mediumint(25)','unsigned' => 'unsigned', 'NULL' => false, 'default' => '0') );
		api_plugin_db_add_column ('nmidCreatePDF', 'plugin_nmidCreatePDF_Reports_scheduler', array('name' => 'archiveUserGroupId', 'type' => 'mediumint(25)','unsigned' => 'unsigned', 'NULL' => false, 'default' => '0'));		
	}
	if ( ( $version_major < 2 ) && ( $version_minor < 70 ) ) {
		$nmid_avail_maxRawData = readConfigOption('nmid_avail_maxRawData');
		db_execute('UPDATE settings SET value=' . $nmid_avail_maxRawData. ' WHERE name = "nmid_avail_PollMaxRawData"');
		api_plugin_db_add_column ('nmidCreatePDF', 'plugin_nmidCreatePDF_Reports_scheduler', array('name' => 'runNow', 'type' => 'mediumint(25)','unsigned' => 'unsigned', 'NULL' => false, 'default' => '0') );
	}
	if ( ( $version_major < 2 ) && ( $version_minor < 72 ) ) {
		api_plugin_register_hook('nmidCreatePDF', 'weathermap_page_selection_top','nmidCreatePDF_printWeathermapButton', 'setup.php');
		api_plugin_db_add_column ('nmidCreatePDF', 'plugin_nmidCreatePDF_Reports_scheduler', array('name' => 'Attachments', 'type' => 'text', 'NULL' => true) );
	}
	if ( $version_build < 32 ) {
		api_plugin_db_add_column ('nmidCreatePDF', 'plugin_nmidCreatePDF_Reports', array('name' => 'showGraphHeader', 'type' => 'varchar(5)', 'NULL' => false, 'default' => '1') );
	}
	if ( $version_build < 34 ) {
		db_execute("ALTER TABLE `plugin_nmidCreatePDF_Availability_SLATimeFrame_Table`  DROP PRIMARY KEY,  ADD PRIMARY KEY (`Id`, `defaultDays`);");
	}
	if ( $version_minor < 83 ) {
		api_plugin_register_hook('nmidCreatePDF', 'device_action_array', 'plugin_nmidCreatePDF_device_action_array', 'setup.php');
		api_plugin_register_hook('nmidCreatePDF', 'device_action_prepare', 'plugin_nmidCreatePDF_device_action_prepare', 'setup.php');
		api_plugin_register_hook('nmidCreatePDF', 'device_action_execute', 'plugin_nmidCreatePDF_device_action_execute', 'setup.php');
	}

	db_execute('UPDATE plugin_hooks SET status = 1 where name = "nmidCreatePDF" AND hook="api_device_save"');
	db_execute('UPDATE plugin_hooks SET status = 1 where name = "nmidCreatePDF" AND hook="tree_after"');
	db_execute('UPDATE plugin_hooks SET status = 1 where name = "nmidCreatePDF" AND hook="weathermap_page_selection_top"');

	// Always do this:
	db_execute('UPDATE plugin_realms SET file = "nmidCreatePDF_orderDSStatsGraphs.php,nmidCreatePDF_addDSStatsReport.php,addToDSStatsReport.php,nmidCreatePDF_createTemplateReport.php,nmidCreatePDF_orderGraphs.php,nmidCreatePDF_scheduler.php,nmidCreatePDF_addScheduledReport.php,addToGraphReport.php,nmidCreatePDF_Reports.php,nmidCreatePDF_addReport.php,nmidCreatePDF_addMultiReport.php,nmidCreatePDF_orderMultiGraphs.php,nmidCreatePDF_Backup.php,nmidCreatePDF_support.php,nmidCreatePDF_debug.php,nmidCreatePDF_ArchiveUserGroups.php,nmidCreatePDF_ArchiveUserGroups_Add.php,nmidCreatePDF_ArchiveUserGroups_AddUser.php,nmidCreatePDF_addWeathermapReport.php" WHERE display = "NMID - Define PDF Reports"');
	db_execute('UPDATE plugin_realms SET file = "nmidCreatePDF_doArchiveReport.php,nmidCreatePDF_Archive.php,nmidCreatePDF_GenerateReports.php,nmidCreatePDF_GenerateReport_now.php" WHERE display = "NMID - Generate PDF Reports"');
	db_execute('UPDATE plugin_realms SET file = "nmidCreatePDF_Availability_DowntimeSchedule.php,nmidCreatePDF_Availability_addDowntimeSchedule.php,nmidCreatePDF_Availability_SLATimeFrame.php,nmidCreatePDF_Availability_addSLATimeFrame.php,nmidCreatePDF_Availability_addSLATimeFrameItem.php,nmidCreatePDF_Availability_SLATimeFrameItem.php" WHERE display = "NMID - Manage Availability Data"');
    db_execute('UPDATE plugin_realms SET file = "nmidCreatePDF_addZenossReport.php,addToZenossReport.php,nmidCreatePDF_orderZenossReports.php" WHERE display = "NMID - Manage Zenoss Reports"');
    db_execute('UPDATE plugin_realms SET file = "nmidCreatePDF_AvailabilityChart.php" WHERE display = "NMID - View Availability Charts"');
}




?>
